from django.db.models import Q
from datetime import date
from datetime import timedelta
import datetime


#from PIL import Image
from django.http import FileResponse
import os


from school.models import(
    users, user_login_category, login_category,
    school_user,
    school,
    student,
    school_student,
    student_exam_score,
    subjects,
    exams_subject,
    view_v_ff_school_sub_class_details_1_a,
    view_v_nn_subject_grades_details_1_a,
    view_v_nn_students_exam_score_details_1_a,
    student_sub_class,
    )
class examsC:

    
    
    def getExamsScore(self, examsId, examsSubjectId, schoolStudentId):
        x=0
        msg=""
        #exams   exams_subject   school_student
        examScore=0.0
        try:
            x=x

            ixc=student_exam_score.objects.values().filter(
                exams_id=examsId, 
                exams_subject_id=examsSubjectId,
                school_student_id=schoolStudentId,
                status='Active')
            for aa in ixc:
                examScore=aa['score']

            
        except Exception as e:
            msg="error failed : " + str(e)
        return examScore
    
    
    def getClassLevelsIdUsingSubClassId(self, subClassId):
        idx=0
        inv=view_v_ff_school_sub_class_details_1_a.objects.values().filter(sub_class_id=subClassId)
        for a in inv:
            idx=a['class_levels_id']
        return idx 
    
    def calculateDivisionPoints(self, divisionPointsList, classLevelsId):
        x=0
        y=0

        z=len(divisionPointsList)

        xList=[]
        while x<z:
            y=0
            while y<z-1:
                if int(divisionPointsList[y]['divisionPoints']) > int(divisionPointsList[y+1]['divisionPoints']):
                    tmp=divisionPointsList[y]
                    divisionPointsList[y]=divisionPointsList[y+1]
                    divisionPointsList[y+1]=tmp
                y=y+1
            x=x+1
        totalPoints=0
        x=0
        if classLevelsId==1:
            for a in divisionPointsList:
                if x<=6:
                    totalPoints+=a['divisionPoints']
                x=x+1

        elif classLevelsId==2:
            for a in divisionPointsList:
                if x<=3:
                    totalPoints+=a['divisionPoints']
                x=x+1
        else:
            x=x
        return totalPoints
    


    def getPositionOfExamsScoreInASubClass(self, examsId, examsSubjectId, schoolStudentId, subClassId):
        x=0
        y=0
        z=0
        msg=""
        #exams   exams_subject   school_student
        #examScore=0.0
        try:
            x=x

            ixc=view_v_nn_students_exam_score_details_1_a.objects.values().filter(
                exams_id=examsId, 
                subjects_id=examsSubjectId,
                school_sub_class_id=subClassId,
                )
            iList=[]
            
            for aa in ixc:
                iList.append({'studentId': aa['student_id'], 'score': aa['score']})

            x=0
            y=0
            z=len(iList)
            while x<z:
                y=0
                while y<z-1:
                    if iList[y]['score']<iList[y+1]['score']:
                        tmp=iList[y]
                        iList[y]=iList[y+1]
                        iList[y+1]=tmp
                    y=y+1
                x=x+1 
            x=1
            y=1
            for ab in iList:
                if ab['studentId']==schoolStudentId:
                    y=x
                x=x+1
            x=len(iList)
        except Exception as e:
            msg="error failed : " + str(e)
        return [y,x]
    

    def getPositionOfExamsAverageScoreInASubClass(self, examsId, subClassId, academicYearId, schoolStudentId ):
        x=0
        y=0
        iList=[]
        try:
            inv=student_sub_class.objects.values().filter(
                
                school_sub_class_id=subClassId,
                academic_year_id=academicYearId,
                status='Active'
                )
            
            for ac in inv:
                x=x

                ixc=view_v_nn_students_exam_score_details_1_a.objects.values().filter(
                    exams_id=examsId, 
                    
                    school_sub_class_id=subClassId,
                    student_id=ac['student_id']
                    )
                #iList=[]
                totalScore=0.0
                for aa in ixc:
                    totalScore+=float(aa['score'])

                iList.append({'studentId': aa['student_id'], 'score': totalScore})
            
                x=0
                y=0
                z=len(iList)
                while x<z:
                    y=0
                    while y<z-1:
                        if iList[y]['score']<iList[y+1]['score']:
                            tmp=iList[y]
                            iList[y]=iList[y+1]
                            iList[y+1]=tmp
                        y=y+1
                    x=x+1 
                x=1
                y=1
                for ab in iList:
                    if ab['studentId']==schoolStudentId:
                        y=x
                    x=x+1
                x=len(iList)

        except Exception as e:
            msg="error failed go78 : " + str(e)
        return [y, x]     
        #return x

    
    def getPositionOfExamsAverageScoreInASubClassold(self, examsId, examsSubjectId, schoolStudentId, subClassId):
        x=0
        y=0
        z=0
        msg=""
        iList=[]
        #exams   exams_subject   school_student
        #examScore=0.0
        try:
            inv=view_v_nn_students_exam_score_details_1_a.objects.values().filter(
                exams_id=examsId, 
                school_sub_class_id=subClassId,
                )
            
            for ac in inv:
                x=x

                ixc=view_v_nn_students_exam_score_details_1_a.objects.values().filter(
                    exams_id=examsId, 
                    subjects_id=examsSubjectId,
                    school_sub_class_id=subClassId,
                    student_id=ac['student_id']
                    )
                iList=[]
                
                for aa in ixc:
                    iList.append({'studentId': aa['student_id'], 'score': aa['score']})
                
                x=0
                y=0
                z=len(iList)
                while x<z:
                    y=0
                    while y<z-1:
                        if iList[y]['score']<iList[y+1]['score']:
                            tmp=iList[y]
                            iList[y]=iList[y+1]
                            iList[y+1]=tmp
                        y=y+1
                    x=x+1 
                x=1
                y=1
                for ab in iList:
                    if ab['studentId']==schoolStudentId:
                        y=x
                    x=x+1
                x=len(iList)
        except Exception as e:
            msg="error failed : " + str(e)
        return [y,x]
    

    def getDivPointsGradesAndRemarksScore(self, examsSubjectId, subClassId, score):
        x=0
        msg=""
        pList=['','', 0,0]
        classLevelsId=self.getClassLevelsIdUsingSubClassId(subClassId)

        print("classLevelsId=" + str(classLevelsId))

        #exams   exams_subject   school_student
        #examScore=0.0
        try:
            x=x
            print("x=" + str(x))
            ixc=view_v_nn_subject_grades_details_1_a.objects.values().filter(
                class_levels_id=classLevelsId, 
                subjects_id=examsSubjectId,
                to_grade_point__gte=score, from_grade_point__lte=score)
            
            print("ixc=" + str(ixc))
            
            for aa in ixc:
                pList=[ aa['grades_name'], aa['remarks'], aa['division_point'], aa['gpa_point']]

            
        except Exception as e:
            msg="error failed ft78 : " + str(e)
            print("error " + msg)
        return pList
    
    
    def sortListOfResultsUsingAverageScore(self, xList):
        iList=[]
        x=0
        y=0
        iList=[]
        z=len(xList)
        print("ahg=" + str(xList[0]))
        print("acg=" + xList[0]['averageScore'])
        try:
            while y<z:
                x=0
                while x<z-1:
                    if float(xList[x]['averageScore'])< float(xList[x+1]['averageScore']):
                        tmp=xList[x]
                        xList[x]=xList[x+1]
                        xList[x+1]=tmp

                    x=x+1
                y=y+1
            iList=xList

            x=0
            while x<z:
                iList[x]['id']=x+1
                x=x+1
        except Exception as e:
                    print("error kui96 except=" + str(e))
        return iList 
    
    def getNumberOfSubjects(self, examsId, subClassId):
        x=0
        msg=""
        #exams   exams_subject   school_student
        numberOfSubjects=0
        try:
            x=x

            ixc=exams_subject.objects.values().filter(
                exams_id=examsId, school_sub_class_id=subClassId,
                status='Active')
            for aa in ixc:
                numberOfSubjects+=1

            
        except Exception as e:
            msg="error failed : " + str(e)
        return numberOfSubjects
    
    

    
    def getExamsSubject(self,  subjectId):
        x=0
        msg=""
        #exams   exams_subject   school_student
        subjectName=""
        try:
            x=x

            ixc=subjects.objects.values().filter(
                id=subjectId, 
                status='Active')
            for aa in ixc:
                subjectName=aa['name']

            
        except Exception as e:
            msg="error failed : " + str(e)
        return subjectName
    
    
    def getDateAfterDays(self, numberDays):
        new_date=''
        try:

            current_date = date.today()
            old_date = current_date #+ timedelta(days=-7)
            new_date = current_date + timedelta(days=180)
        except Exception as e:
            print("try catch error A0103: " + str(e))
        return new_date
    
    def convertDateToYMD(self, dateArg):
        dateYMD=''
        try:
            dateYMD=''
            #dDate=datetime.date.today()
            yYear=str(dateArg.year)
            mMonth=str(dateArg.month)
            dDay=str(dateArg.day)
            dateYMD=yYear + '-' + mMonth + '-' + dDay
        except Exception as e:
            print("try catch error A0107: " + str(e))
        
        return dateYMD
    
    def getTodayDate(self):
        todayDateStr=''
        try:
            todayDate=datetime.date.today()
            todayYear=str(datetime.date.today().year)
            todayMonth=str(datetime.date.today().month)
            todayDay=str(datetime.date.today().day)
            if len(todayMonth)==1:
                todayMonth='0' + todayMonth
            if len(todayDay)==1:
                todayDay='0' + todayDay

            todayDateStr= todayYear + '-' + todayMonth + '-' + todayDay
        except Exception as e:
            print("try catch error A0109: " + str(e))
        
        return todayDateStr

    def getTodayTime(self):
        todayTimeStr=''
        try:
            todayTime=datetime.datetime.now()
            todayHour=str(datetime.datetime.now().hour)
            todayMinute=str(datetime.datetime.now().minute)
            todaySecond=str(datetime.datetime.now().second)

            todayTimeStr= todayHour + ':' + todayMinute + ':' + todaySecond + '.000000'
        except Exception as e:
            print("try catch error A0121: " + str(e))
        
        return todayTimeStr
    
    
    
   
    def lookIfMobileNoExists(self, mobileNumber):
        x=0
        msg=""
        try:
            x=x
            ixc=users.objects.values().filter(mobile_number=mobileNumber, status='Active')
            x=len(list(ixc))
            msg="success"
        except Exception as e:
            msg="error failed : " + str(e)
        return [x, msg]
    

    def getUserIdUsingMobileNo(self, mobileNumber):
        x=0
        msg=""
        id=0
        try:
            x=x
            ixc=users.objects.values().filter(mobile_number=mobileNumber, status='Active')
            for a in ixc:
                id=a['id']
            if id>0:
                msg="success"

            
        except Exception as e:
            msg="error failed : " + str(e)
        return [id, msg]
    
    def getStudentIdUsingStudentDetails(self, firstName, middleName, lastName, firstMobileNumber, secondMobileNumber):
        x=0
        msg=""
        id=0
        try:
            x=x
            ixc=student.objects.values().filter(
                    first_name=firstName,
                    middle_name=middleName,
                    last_name=lastName,
                    first_mobile_number=firstMobileNumber,
                    second_mobile_number=secondMobileNumber,
                    status= 'Active',
                )
            for a in ixc:
                id=a['id']
            if id>0:
                msg="success"

            
        except Exception as e:
            msg="error failed : " + str(e)
        return [id, msg]
    

    
    def getUserLoginCategoryIdUsingCategoryName(self, categoryName):
        x=0
        msg=""
        id=0
        try:
            x=x
            ixc=login_category.objects.values().filter(name=categoryName, status='Active')
            for a in ixc:
                id=a['id']
            if id>0:
                msg="success"

            
        except Exception as e:
            msg="error failed : " + str(e)
        return [id, msg] 
    


    
    def getUserSchoolNameUsingUserId(self, userId):
        x=0
        msg="not success"
        id=0
        schoolId=0
        schoolName=""
        try:
            x=x
            ixc=school_user.objects.values().filter(users_id=userId, status='Active')
            
            for a in ixc:
                schoolId=a['school_id']
                id=1
            
            if id>0:
                msg="success"

            icx=school.objects.values().filter(id=schoolId, status='Active')
            
            for a in icx:
                schoolName=a['name']
                id=1

            
        except Exception as e:
            msg="error failed : " + str(e)
        return [schoolId, schoolName, msg]
       
    
    
   