from django.shortcuts import render
import json

# Create your views here.
from django.shortcuts import render
from django.shortcuts import render
from django.http import HttpResponse
from rest_framework import generics,status
from rest_framework.views import APIView
from rest_framework.response import Response


from school.serializers import (
SchoolsViewSerializer,
SchoolsViewAllDetailsSerializer,
CreateSchoolsSerializer,
CitiesViewSerializer,
DistrictsViewSerializer,
WardsViewSerializer,
UsersDetailsSerializer,
SchoolAdminsDetailsSerializer,
StudentsDetailsSerializer,
SchoolClassDetailsSerializer,
SchoolSubClassDetailsSerializer,

SingleSchoolSubClassDetailsSerializer,

SchoolClassViewDetailsSerializer,
AcademicYearDetailsSerializer,
StudentInAStreamSerializer,
SubjectsDetailsSerializer,
ExamsDetailsSerializer,
ClassLevelsSerializer,
SchoolExamsSerializer,
ExamSubjectsSerializer,
StudentExamScoreSerializer,
StudentsWithSubClassesDetailsSerializer,
TeachersSubjectsSerializer,
StudentsExamScoreSerializer,
SingleTeacherExamSubjectsSerializer,

SingleSchoolExamsSerializer,

StudentSubClassToCopySerializer,

 )
 
from school.models import (
school,
view_v_bb_schools_1_a,
view_v_user_details_1_a,
view_v_gg_school_admins_details_1_a,
city,
district,
ward,
users, student, school_student,
school_user, user_password, user_login_category,
school_class, school_sub_class, academic_year,
view_v_cc_school_class_1_a,
view_v_aa_student_details_1_a,
student_sub_class, subjects,
exams, class_levels, exams_subject,
view_v_dd_school_exam_subjects_1_a,
student_exam_score,
view_v_ff_school_sub_class_details_1_a,
view_v_ab_student_details_1_a,
view_v_hh_teacher_subjects_details_1_a,
teacher_subjects,
view_v_nn_students_exam_score_details_1_a,
view_v_hj_teachers_exam_subjects_details_1_a,
view_v_dd_exams_details_1_a,


)

""" from tax.general.general import general
from tax.usersc.usersc import usersc
from tax.taxclass.taxclass import taxclass """

""" newGeneral=general()
newUser=usersc()
newTaxClass=taxclass()
 """
from school.general.general import general
from school.users.users import usersC
from school.exams.exams import examsC


from school.schools.schools import schoolsC

newGeneral=general()
newUser=usersC()
newSchool=schoolsC()
newExams=examsC()


class WardsView(APIView):
      def get(self, request, format=None):
        queryset=''
        try:
            queryset=ward.objects.values()#.filter()
            print("queryset=" + str(queryset))
            serializer_class= WardsViewSerializer
            serializer= WardsViewSerializer(city,many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)



class DistrictsView(APIView):
      def get(self, request, format=None):
        queryset=''
        try:
            queryset=district.objects.values()#.filter()
            print("queryset=" + str(queryset))
            serializer_class= DistrictsViewSerializer
            serializer= DistrictsViewSerializer(city,many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)



class CitiesView(APIView):
      def get(self, request, format=None):
        queryset=''
        try:
            queryset=city.objects.values()#.filter()
            print("queryset=" + str(queryset))
            serializer_class= CitiesViewSerializer
            serializer= CitiesViewSerializer(city,many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)


class SchoolsView(APIView):
      def get(self, request, format=None):
        queryset=''
        try:
            
            queryset=view_v_bb_schools_1_a.objects.values()#.filter()
            print("queryset=" + str(queryset))
            serializer_class= SchoolsViewAllDetailsSerializer
            serializer= SchoolsViewAllDetailsSerializer(view_v_bb_schools_1_a,many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)



class SchoolClassView(APIView):
      def get(self, request, schoolId, format=None):
        queryset=''
        try:
            
            queryset=view_v_cc_school_class_1_a.objects.values().filter(school_id=schoolId)
            #print("queryset=" + str(queryset))
            serializer_class= SchoolClassViewDetailsSerializer
            serializer= SchoolClassViewDetailsSerializer(school,many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)




class SingleSchoolClassView(APIView):
      def get(self, request, schoolId, format=None):
        queryset=''
        try:
            
            queryset=view_v_cc_school_class_1_a.objects.values().filter(school_id=schoolId)
            print("queryset=" + str(queryset))
            serializer_class= SchoolClassViewDetailsSerializer
            serializer= SchoolClassViewDetailsSerializer(school,many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)




class CreateSchoolsView(APIView):
    serializer_class= CreateSchoolsSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        datax=str(request.data)
        idx=0
        msg=""
        schoolCode=""
        try:
            #CreateSchool   getSchoolCode
            schoolCode=newSchool.getSchoolCode()
            inv=school(
                 ward_id= request.data['ward'],
                 status= request.data['status'],
                 name= request.data['name'],
                 school_code= schoolCode,
                 street= request.data['street'],
                 plot_number= request.data['plot_number'],
                 area_details= request.data['area_details'],
                 telephone_number_1= request.data['telephone_number_1'],
                 telephone_number_2= request.data['telephone_number_2'],
                 email= request.data['email'],
                 website= request.data['website']
                 )
            
            inv.save()
            """
            id = models.BigAutoField(primary_key=True)
            ward=models.ForeignKey(district, on_delete=models.CASCADE)
            status=models.CharField(max_length=32)
            name=models.CharField(max_length=128)
            school_code=models.CharField(max_length=16, default="")
            street=models.CharField(max_length=32)
            plot_number=models.CharField(max_length=32)
            area_details=models.CharField(max_length=128)
            telephone_number_1=models.CharField(max_length=16)
            telephone_number_2=models.CharField(max_length=16)
            email=models.CharField(max_length=128)
            website=models.CharField(max_length=128)
            """
            #print("123")
            ### 
            
            msg="School was successfully created"
            """    """
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #
        return Response({ 'status': str(status.HTTP_201_CREATED), 'msg': msg, 'datax': datax})

#""" """




class UpdateSchoolsView(APIView):
    serializer_class= CreateSchoolsSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        datax=str(request.data)
        idx=0
        msg=""
        schoolCode=""
        schoolId=0
        try:
            #CreateSchool   getSchoolCode
            #schoolCode=newSchool.getSchoolCode()
            schoolId=request.data['status']

            inv=school.objects.values().filter(id=schoolId, status='Active').update(
                 ward_id= request.data['ward'],
                 
                 name= request.data['name'], 
                 #school_code= schoolCode,
                 street= request.data['street'],
                 plot_number= request.data['plot_number'],
                 area_details= request.data['area_details'],
                 telephone_number_1= request.data['telephone_number_1'],
                 telephone_number_2= request.data['telephone_number_2'],
                 email= request.data['email'],
                 website= request.data['website']
                 )
            
            #inv.save()
            """
            id = models.BigAutoField(primary_key=True)
            ward=models.ForeignKey(district, on_delete=models.CASCADE)
            status=models.CharField(max_length=32)
            name=models.CharField(max_length=128)
            school_code=models.CharField(max_length=16, default="")
            street=models.CharField(max_length=32)
            plot_number=models.CharField(max_length=32)
            area_details=models.CharField(max_length=128)
            telephone_number_1=models.CharField(max_length=16)
            telephone_number_2=models.CharField(max_length=16)
            email=models.CharField(max_length=128)
            website=models.CharField(max_length=128)
            """
            #print("123")
            ### 
            
            msg="School was successfully updated"
            """    """
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #
        return Response({ 'status': str(status.HTTP_201_CREATED), 'msg': msg, 'datax': datax})

#""" """

class CreateSchoolAdminView(APIView):
    serializer_class= UsersDetailsSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        datax=str(request.data)
        idx=0
        msg=""
        try:
            """
            first_name=models.CharField(max_length=32)
            middle_name=models.CharField(max_length=32)
            last_name=models.CharField(max_length=32)
            status=models.CharField(max_length=32)
            gender=models.CharField(max_length=16)
            mobile_number=models.CharField(max_length=16)
            user_email=models.EmailField(max_length=128)
            date_of_birth=models.DateTimeField()
            """

            firstName=request.data['first_name']
            middleName=request.data['middle_name']
            lastName=request.data['last_name']

            gender=request.data['gender']
            mobileNumber=request.data['mobile_number']
            userEmail=request.data['user_email']
            dateOfBirth=request.data['date_of_birth']
            userPassword=request.data['user_password']
            
            x=0
            [x, msg]=newUser.lookIfMobileNoExists(mobileNumber)
            idx=0
            schoolId=0
            schoolId=int(request.data['full_name'])
            issueDate=newGeneral.getTodayDate()
            numberDays=120
            expireDate=newGeneral.getDateAfterDays(numberDays)
            expireDate=newGeneral.convertDateToYMD(expireDate)

            
            #login_category
            categoryName="School Administrator"
            userLoginCategoryId=0
            [userLoginCategoryId, msg]=newUser.getUserLoginCategoryIdUsingCategoryName(categoryName)
            

            if x==0:
                inv=users(
                    first_name=firstName,
                    middle_name=middleName,
                    last_name=lastName,
                    gender=gender,
                    mobile_number=mobileNumber,
                    user_email=userEmail,
                    date_of_birth=dateOfBirth,
                    status= 'Active',
                    )
                
                inv.save()
                
                [idx, msg]=newUser.getUserIdUsingMobileNo(mobileNumber)

                inv=school_user(
                     users_id=idx,
                     school_id=schoolId,
                     status='Active'
                )
                inv.save() 

                inv=user_password(
                     users_id_id=idx,
                     password=userPassword,
                     issue_date=issueDate,
                     expire_date=expireDate,
                     status='Active'
                )
                inv.save()

                inv=user_login_category(
                     users_id_id=idx,
                     login_category_id_id=userLoginCategoryId,
                     status='Active'
                )
                inv.save()

                msg="School Admin was successfully created"

            else:
                 msg="A user with similar mobile numbers has already been created"
            """
            id = models.BigAutoField(primary_key=True)
            ward=models.ForeignKey(district, on_delete=models.CASCADE)
            status=models.CharField(max_length=32)
            name=models.CharField(max_length=128)
            school_code=models.CharField(max_length=16, default="")
            street=models.CharField(max_length=32)
            plot_number=models.CharField(max_length=32)
            area_details=models.CharField(max_length=128)
            telephone_number_1=models.CharField(max_length=16)
            telephone_number_2=models.CharField(max_length=16)
            email=models.CharField(max_length=128)
            website=models.CharField(max_length=128)
            """
            #print("123")
            ### 
            
            #msg="School was successfully created"
            """    """
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #
        return Response({ 'status': str(status.HTTP_201_CREATED), 'msg': msg, 'datax': datax})






class CreateSchoolTeacherView(APIView):
    serializer_class= UsersDetailsSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        datax=str(request.data)
        idx=0
        msg=""
        try:
            """
            first_name=models.CharField(max_length=32)
            middle_name=models.CharField(max_length=32)
            last_name=models.CharField(max_length=32)
            status=models.CharField(max_length=32)
            gender=models.CharField(max_length=16)
            mobile_number=models.CharField(max_length=16)
            user_email=models.EmailField(max_length=128)
            date_of_birth=models.DateTimeField()
            """

            firstName=request.data['first_name']
            middleName=request.data['middle_name']
            lastName=request.data['last_name']

            gender=request.data['gender']
            mobileNumber=request.data['mobile_number']
            userEmail=request.data['user_email']
            dateOfBirth=request.data['date_of_birth']
            userPassword=request.data['user_password']
            
            x=0
            [x, msg]=newUser.lookIfMobileNoExists(mobileNumber)
            idx=0
            schoolId=0
            schoolId=int(request.data['full_name'])
            issueDate=newGeneral.getTodayDate()
            numberDays=120
            expireDate=newGeneral.getDateAfterDays(numberDays)
            expireDate=newGeneral.convertDateToYMD(expireDate)

            
            #login_category
            categoryName="School Teacher"
            userLoginCategoryId=0
            [userLoginCategoryId, msg]=newUser.getUserLoginCategoryIdUsingCategoryName(categoryName)
            

            if x==0:
                inv=users(
                    first_name=firstName,
                    middle_name=middleName,
                    last_name=lastName,
                    gender=gender,
                    mobile_number=mobileNumber,
                    user_email=userEmail,
                    date_of_birth=dateOfBirth,
                    status= 'Active',
                    )
                
                inv.save()
                
                [idx, msg]=newUser.getUserIdUsingMobileNo(mobileNumber)

                inv=school_user(
                     users_id=idx,
                     school_id=schoolId,
                     status='Active'
                )
                inv.save() 

                inv=user_password(
                     users_id_id=idx,
                     password=userPassword,
                     issue_date=issueDate,
                     expire_date=expireDate,
                     status='Active'
                )
                inv.save()

                inv=user_login_category(
                     users_id_id=idx,
                     login_category_id_id=userLoginCategoryId,
                     status='Active'
                )
                inv.save()

                msg="School Teacher was successfully created"

            else:
                 msg="A user with similar mobile numbers has already been created"
            """
            id = models.BigAutoField(primary_key=True)
            ward=models.ForeignKey(district, on_delete=models.CASCADE)
            status=models.CharField(max_length=32)
            name=models.CharField(max_length=128)
            school_code=models.CharField(max_length=16, default="")
            street=models.CharField(max_length=32)
            plot_number=models.CharField(max_length=32)
            area_details=models.CharField(max_length=128)
            telephone_number_1=models.CharField(max_length=16)
            telephone_number_2=models.CharField(max_length=16)
            email=models.CharField(max_length=128)
            website=models.CharField(max_length=128)
            """
            #print("123")
            ### 
            
            #msg="School was successfully created"
            """    """
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #
        return Response({ 'status': str(status.HTTP_201_CREATED), 'msg': msg, 'datax': datax})




#""" """
class UpdateSchoolAdminView(APIView):
    serializer_class= UsersDetailsSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        datax=str(request.data)
        idx=0
        msg=""
        try:
            """
            first_name=models.CharField(max_length=32)
            middle_name=models.CharField(max_length=32)
            last_name=models.CharField(max_length=32)
            status=models.CharField(max_length=32)
            gender=models.CharField(max_length=16)
            mobile_number=models.CharField(max_length=16)
            user_email=models.EmailField(max_length=128)
            date_of_birth=models.DateTimeField()
            """
            
            usersId=request.data['users_id']
            firstName=request.data['first_name']
            middleName=request.data['middle_name']
            lastName=request.data['last_name']

            gender=request.data['gender']
            mobileNumber=request.data['mobile_number']
            userEmail=request.data['user_email']
            dateOfBirth=request.data['date_of_birth']
            userPassword=request.data['user_password']
            
            x=0
            [x, msg]=newUser.lookIfMobileNoExists(mobileNumber)
            idx=0
            schoolId=0
            schoolId=int(request.data['full_name'])
            issueDate=newGeneral.getTodayDate()
            numberDays=120
            expireDate=newGeneral.getDateAfterDays(numberDays)
            expireDate=newGeneral.convertDateToYMD(expireDate)

            
            #login_category
            categoryName="School Administrator"
            userLoginCategoryId=0
            [userLoginCategoryId, msg]=newUser.getUserLoginCategoryIdUsingCategoryName(categoryName)
            

            if x>0:
                inv=users.objects.values().filter(id=usersId, status= 'Active').update(
                    first_name=firstName,
                    middle_name=middleName,
                    last_name=lastName,
                    gender=gender,
                    mobile_number=mobileNumber,
                    user_email=userEmail,
                    date_of_birth=dateOfBirth,
                    
                    )
                
                #inv.save()
                
                #[idx, msg]=newUser.getUserIdUsingMobileNo(mobileNumber)
                idx=usersId
                inv=school_user.objects.values().filter(users_id=usersId).update(
                     school_id=schoolId,
                     status='Active'
                )
                #inv.save() 

                inv=user_password.objects.values().filter(users_id_id=usersId, status='Active').update(
                    
                     password=userPassword,
                     issue_date=issueDate,
                     expire_date=expireDate,
                     
                )
                #inv.save()

                

                msg="School Admin was successfully updated"

            else:
                 msg="User does not exist"
            """
            id = models.BigAutoField(primary_key=True)
            ward=models.ForeignKey(district, on_delete=models.CASCADE)
            status=models.CharField(max_length=32)
            name=models.CharField(max_length=128)
            school_code=models.CharField(max_length=16, default="")
            street=models.CharField(max_length=32)
            plot_number=models.CharField(max_length=32)
            area_details=models.CharField(max_length=128)
            telephone_number_1=models.CharField(max_length=16)
            telephone_number_2=models.CharField(max_length=16)
            email=models.CharField(max_length=128)
            website=models.CharField(max_length=128)
            """
            #print("123")
            ### 
            
            #msg="School was successfully created"
            """    """
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #
        return Response({ 'status': str(status.HTTP_201_CREATED), 'msg': msg, 'datax': datax})



class CreateSchoolStudentView(APIView):
    serializer_class= StudentsDetailsSerializer#UsersDetailsSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        datax=str(request.data)
        idx=0
        msg=""
        try:
            """
            first_name=models.CharField(max_length=32)
            middle_name=models.CharField(max_length=32)
            last_name=models.CharField(max_length=32)
            date_of_birth=models.DateTimeField()
            
            gender=models.CharField(max_length=16)
            first_parent_name=models.CharField(max_length=64)
            first_mobile_number=models.CharField(max_length=16)
            second_parent_name=models.CharField(max_length=64)
            second_mobile_number=models.CharField(max_length=16)
            #user_email=models.EmailField(max_length=128)
            status=models.CharField(max_length=16)
            """

            firstName=request.data['first_name']
            middleName=request.data['middle_name']
            lastName=request.data['last_name']
            dateOfBirth=request.data['date_of_birth']

            gender=request.data['gender']

            firstParentName=request.data['first_parent_name']
            firstMobileNumber=request.data['first_mobile_number']

            secondParentName=request.data['second_parent_name']
            secondMobileNumber=request.data['second_mobile_number']
            
            schoolName=request.data['school_name']

            #student_status academicYearId
            academicYearId=request.data['student_status']
            #full_name schoolSubClassId
            schoolSubClassId=request.data['full_name']
            
            x=0
            #[x, msg]=newUser.lookIfMobileNoExists(mobileNumber)
            idx=0
            schoolId=0
            schoolId=int(schoolName)
            """
            issueDate=newGeneral.getTodayDate()
            numberDays=120
            expireDate=newGeneral.getDateAfterDays(numberDays)
            expireDate=newGeneral.convertDateToYMD(expireDate)
            """
            
            #login_category
            """
            categoryName="School Administrator"
            userLoginCategoryId=0
            [userLoginCategoryId, msg]=newUser.getUserLoginCategoryIdUsingCategoryName(categoryName)
            """
            x=0
            if x==0:
                inv=student(
                    first_name=firstName,
                    middle_name=middleName,
                    last_name=lastName,
                    date_of_birth=dateOfBirth,
                    gender=gender,
                    first_parent_name=firstParentName,
                    first_mobile_number=firstMobileNumber,
                    second_parent_name=secondParentName,
                    second_mobile_number=secondMobileNumber,
                    status= 'Active',
                    )
                
                inv.save()
                
                [idx, msg]=newUser.getStudentIdUsingStudentDetails( firstName, middleName, lastName, firstMobileNumber, secondMobileNumber)

                inv=school_student(
                     student_id=idx,
                     school_id=schoolId,
                     status='Active'
                )
                inv.save() 

                #student_status academicYearId
                #full_name schoolSubClassId

                inv=student_sub_class(
                    student_id=idx, 
                    academic_year_id=academicYearId,
                    school_sub_class_id=schoolSubClassId,
                    status= 'Active',
                    )
                
                inv.save()
                """ HEREX3
                inv=user_password(
                     users_id_id=idx,
                     password=userPassword,
                     issue_date=issueDate,
                     expire_date=expireDate,
                     status='Active'
                )
                inv.save()
                """
                """
                inv=user_login_category(
                     users_id_id=idx,
                     login_category_id_id=userLoginCategoryId,
                     status='Active'
                )
                inv.save()
                """
                msg="School Student was successfully created"

            else:
                 msg="A student with similar mobile numbers has already been created"
            """
            id = models.BigAutoField(primary_key=True)
            ward=models.ForeignKey(district, on_delete=models.CASCADE)
            status=models.CharField(max_length=32)
            name=models.CharField(max_length=128)
            school_code=models.CharField(max_length=16, default="")
            street=models.CharField(max_length=32)
            plot_number=models.CharField(max_length=32)
            area_details=models.CharField(max_length=128)
            telephone_number_1=models.CharField(max_length=16)
            telephone_number_2=models.CharField(max_length=16)
            email=models.CharField(max_length=128)
            website=models.CharField(max_length=128)
            """
            #print("123")
            ### 
            
            #msg="School was successfully created"
            """    """
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #
        return Response({ 'status': str(status.HTTP_201_CREATED), 'msg': msg, 'datax': datax})








class UpdateSchoolStudentView(APIView):
    serializer_class= StudentsDetailsSerializer#UsersDetailsSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        datax=str(request.data)
        idx=0
        msg=""
        try:
            """
            first_name=models.CharField(max_length=32)
            middle_name=models.CharField(max_length=32)
            last_name=models.CharField(max_length=32)
            date_of_birth=models.DateTimeField()
            
            gender=models.CharField(max_length=16)
            first_parent_name=models.CharField(max_length=64)
            first_mobile_number=models.CharField(max_length=16)
            second_parent_name=models.CharField(max_length=64)
            second_mobile_number=models.CharField(max_length=16)
            #user_email=models.EmailField(max_length=128)
            status=models.CharField(max_length=16)
            """
            
            studentId=request.data['student_id']
            firstName=request.data['first_name']
            middleName=request.data['middle_name']
            lastName=request.data['last_name']
            dateOfBirth=request.data['date_of_birth']

            gender=request.data['gender']

            firstParentName=request.data['first_parent_name']
            firstMobileNumber=request.data['first_mobile_number']

            secondParentName=request.data['second_parent_name']
            secondMobileNumber=request.data['second_mobile_number']
            
            schoolName=request.data['school_name']

            #student_status academicYearId
            academicYearId=request.data['student_status']
            #full_name schoolSubClassId
            schoolSubClassId=request.data['full_name']
            
            x=0
            #[x, msg]=newUser.lookIfMobileNoExists(mobileNumber)
            idx=0
            schoolId=0
            schoolId=int(schoolName)
            """
            issueDate=newGeneral.getTodayDate()
            numberDays=120
            expireDate=newGeneral.getDateAfterDays(numberDays)
            expireDate=newGeneral.convertDateToYMD(expireDate)
            """
            
            #login_category
            """
            categoryName="School Administrator"
            userLoginCategoryId=0
            [userLoginCategoryId, msg]=newUser.getUserLoginCategoryIdUsingCategoryName(categoryName)
            """
            x=0
            if x==0:
                inv=student.objects.values().filter(id=studentId,status= 'Active').update(
                    first_name=firstName,
                    middle_name=middleName,
                    last_name=lastName,
                    date_of_birth=dateOfBirth,
                    gender=gender,
                    first_parent_name=firstParentName,
                    first_mobile_number=firstMobileNumber,
                    second_parent_name=secondParentName,
                    second_mobile_number=secondMobileNumber,
                    
                    )
                
                #inv.save()
                
                #[idx, msg]=newUser.getStudentIdUsingStudentDetails( firstName, middleName, lastName, firstMobileNumber, secondMobileNumber)
                idx=studentId
                
               

                #student_status academicYearId
                #full_name schoolSubClassId

                inv=student_sub_class.objects.values().filter(student_id=idx, status= 'Active').update(
                     
                    academic_year_id=academicYearId,
                    school_sub_class_id=schoolSubClassId,
                    
                    )
                
                #inv.save()
                """ HEREX3
                inv=user_password(
                     users_id_id=idx,
                     password=userPassword,
                     issue_date=issueDate,
                     expire_date=expireDate,
                     status='Active'
                )
                inv.save()
                """
                """
                inv=user_login_category(
                     users_id_id=idx,
                     login_category_id_id=userLoginCategoryId,
                     status='Active'
                )
                inv.save()
                """
                msg="School Student was successfully updated"

            else:
                 msg="A student with similar mobile numbers has already been created"
            """
            id = models.BigAutoField(primary_key=True)
            ward=models.ForeignKey(district, on_delete=models.CASCADE)
            status=models.CharField(max_length=32)
            name=models.CharField(max_length=128)
            school_code=models.CharField(max_length=16, default="")
            street=models.CharField(max_length=32)
            plot_number=models.CharField(max_length=32)
            area_details=models.CharField(max_length=128)
            telephone_number_1=models.CharField(max_length=16)
            telephone_number_2=models.CharField(max_length=16)
            email=models.CharField(max_length=128)
            website=models.CharField(max_length=128)
            """
            #print("123")
            ### 
            
            #msg="School was successfully created"
            """    """
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #
        return Response({ 'status': str(status.HTTP_201_CREATED), 'msg': msg, 'datax': datax})






class CreateSchoolClassView(APIView):
    serializer_class= SchoolClassDetailsSerializer#UsersDetailsSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        datax=str(request.data)
        idx=0
        msg=""
        try:
            """
            
            """
            idx=0
            schoolId=0
            schoolId=request.data['school']
            
            classLevelsId=0
            classLevelsId=request.data['class_levels']
            
            className=request.data['name']
            
            x=0
            #[x, msg]=newUser.lookIfMobileNoExists(mobileNumber)
            
            if x==0:
                inv=school_class(
                    school_id=schoolId,
                    class_levels_id=classLevelsId,
                    name=className,
                    status= 'Active',
                    )
                
                inv.save()
                
                #[idx, msg]=newUser.getStudentIdUsingStudentDetails( firstName, middleName, lastName, firstMobileNumber, secondMobileNumber)

               
                """
                
                """
                msg="School Class was successfully created"

            else:
                 msg="A user with similar mobile numbers has already been created"
            """
            id = models.BigAutoField(primary_key=True)
            ward=models.ForeignKey(district, on_delete=models.CASCADE)
            status=models.CharField(max_length=32)
            name=models.CharField(max_length=128)
            school_code=models.CharField(max_length=16, default="")
            street=models.CharField(max_length=32)
            plot_number=models.CharField(max_length=32)
            area_details=models.CharField(max_length=128)
            telephone_number_1=models.CharField(max_length=16)
            telephone_number_2=models.CharField(max_length=16)
            email=models.CharField(max_length=128)
            website=models.CharField(max_length=128)
            """
            #print("123")
            ### 
            
            #msg="School was successfully created"
            """    """
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #
        return Response({ 'status': str(status.HTTP_201_CREATED), 'msg': msg, 'datax': datax})






class DeleteSchoolClassView(APIView):
    serializer_class= SchoolClassDetailsSerializer#UsersDetailsSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        datax=str(request.data)
        idx=0
        msg=""
        try:
            """
            
            """
            idx=request.data['id']
            #schoolId=0
            #schoolId=request.data['school']
            
            #classLevelsId=0
            #classLevelsId=request.data['class_levels']
            
            #className=request.data['name']
            
            x=0
            #[x, msg]=newUser.lookIfMobileNoExists(mobileNumber)
            
            if x==0:
                inv=school_sub_class.objects.values().filter(
                    id=idx,
                    status= 'Active',
                    ).update(status= 'InActive',)
                
                #inv.save()
                
                #[idx, msg]=newUser.getStudentIdUsingStudentDetails( firstName, middleName, lastName, firstMobileNumber, secondMobileNumber)

               
                """
                
                """
                msg="School stream was successfully deleted"

            else:
                 msg="A user with similar mobile numbers has already been created"
            """
            id = models.BigAutoField(primary_key=True)
            ward=models.ForeignKey(district, on_delete=models.CASCADE)
            status=models.CharField(max_length=32)
            name=models.CharField(max_length=128)
            school_code=models.CharField(max_length=16, default="")
            street=models.CharField(max_length=32)
            plot_number=models.CharField(max_length=32)
            area_details=models.CharField(max_length=128)
            telephone_number_1=models.CharField(max_length=16)
            telephone_number_2=models.CharField(max_length=16)
            email=models.CharField(max_length=128)
            website=models.CharField(max_length=128)
            """
            #print("123")
            ### 
            
            #msg="School was successfully created"
            """    """
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #
        return Response({ 'status': str(status.HTTP_201_CREATED), 'msg': msg, 'datax': datax})





class CreateStudentInAStreamView(APIView):
    serializer_class= StudentInAStreamSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        datax=str(request.data)
        idx=0
        msg=""
        try:
            """
            
            """
            idx=0
            studentId=0
            studentId=request.data['student']
            academicYearId=0
            academicYearId=request.data['academic_year']
            schoolSubClassId=0
            schoolSubClassId=request.data['school_sub_class']
            status=request.data['status']
            
            print("123QWE")

            x=0
            #[x, msg]=newUser.lookIfMobileNoExists(mobileNumber)
            
            if x==0:
                inv=student_sub_class(
                    student_id=studentId, 
                    academic_year_id=academicYearId,
                    school_sub_class_id=schoolSubClassId,
                    status= 'Active',
                    )
                
                inv.save()
                
                #[idx, msg]=newUser.getStudentIdUsingStudentDetails( firstName, middleName, lastName, firstMobileNumber, secondMobileNumber)

               
                """
                
                """
                msg="Student was successfully assigned to a stream"

            else:
                 msg="A user with similar mobile numbers has already been created"
            
            #print("123")
            ### 
            
            #msg="School was successfully created"
            """    """
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #
        return Response({ 'status': str('status.HTTP_201_CREATED'), 'msg': msg, 'datax': datax})






class CreateExamsView(APIView):
    serializer_class= ExamsDetailsSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        datax=str(request.data)
        idx=0
        msg=""
        try:
            """
            
            """
            idx=0
            schoolId=0
            schoolId=request.data['school']
            academicYearId=0
            academicYearId=request.data['academic_year']
            classLevelsId=0
            classLevelsId=request.data['class_levels']
            examsName=request.data['name']
            status=request.data['status']
            
            print("XDR123QWE")

            x=0
            #[x, msg]=newUser.lookIfMobileNoExists(mobileNumber)
            
            if x==0:
                inv=exams(
                    school_id=schoolId, 
                    academic_year_id=academicYearId,
                    class_levels_id=classLevelsId,
                    name= examsName,
                    status= 'Active',
                    )
                
                inv.save()
                
                #[idx, msg]=newUser.getStudentIdUsingStudentDetails( firstName, middleName, lastName, firstMobileNumber, secondMobileNumber)

               
                """
                
                """
                msg="Exam was successfully created"

            else:
                 msg="A user with similar mobile numbers has already been created"
            
            #print("123")
            ### 
            
            #msg="School was successfully created"
            """    """
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #
        return Response({ 'status': str('status.HTTP_201_CREATED'), 'msg': msg, 'datax': datax})







class DeleteExamsView(APIView):
    serializer_class= ExamsDetailsSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        datax=str(request.data)
        idx=0
        msg=""
        try:
            """
            
            """
            idx=request.data['id']
            
            
            #print("XDR123QWE")

            x=0
            #[x, msg]=newUser.lookIfMobileNoExists(mobileNumber)
            
            if x==0:
                inv=exams.objects.values().filter(
                    id=idx, 
                    ).update(status='InActive')
                
                #inv.save()
                
                #[idx, msg]=newUser.getStudentIdUsingStudentDetails( firstName, middleName, lastName, firstMobileNumber, secondMobileNumber)

               
                """
                
                """
                msg="Exam was successfully deleted"

            else:
                 msg="A user with similar mobile numbers has already been created"
            
            #print("123")
            ### 
            
            #msg="School was successfully created"
            """    """
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #
        return Response({ 'status': str('status.HTTP_201_CREATED'), 'msg': msg, 'datax': datax})



class CreateSchoolClassViewX(APIView):
    serializer_class= SchoolClassDetailsSerializer#UsersDetailsSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        datax=str(request.data)
        idx=0
        msg=""
        try:
            """
            
            """
            idx=0
            schoolId=0
            schoolId=request.data['school']
            
            className=request.data['name']
            
            x=0
            #[x, msg]=newUser.lookIfMobileNoExists(mobileNumber)
            
            if x==0:
                inv=school_class(
                    school_id=schoolId,
                    name=className,
                    status= 'Active',
                    )
                
                inv.save()
                
                #[idx, msg]=newUser.getStudentIdUsingStudentDetails( firstName, middleName, lastName, firstMobileNumber, secondMobileNumber)

               
                """
                
                """
                msg="School Class was successfully created"

            else:
                 msg="A user with similar mobile numbers has already been created"
            """
            id = models.BigAutoField(primary_key=True)
            ward=models.ForeignKey(district, on_delete=models.CASCADE)
            status=models.CharField(max_length=32)
            name=models.CharField(max_length=128)
            school_code=models.CharField(max_length=16, default="")
            street=models.CharField(max_length=32)
            plot_number=models.CharField(max_length=32)
            area_details=models.CharField(max_length=128)
            telephone_number_1=models.CharField(max_length=16)
            telephone_number_2=models.CharField(max_length=16)
            email=models.CharField(max_length=128)
            website=models.CharField(max_length=128)
            """
            #print("123")
            ### 
            
            #msg="School was successfully created"
            """    """
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #
        return Response({ 'status': str(status.HTTP_201_CREATED), 'msg': msg, 'datax': datax})





class CreateSchoolSubClassView(APIView):
    serializer_class= SchoolSubClassDetailsSerializer 
    #UsersDetailsSerializer#SchoolSubClassDetailsSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        datax=str(request.data)
        idx=0
        msg=""
        try:
            """
            """
            idx=0
            schoolClassId=0
            schoolClassId=request.data['school_class']
            subClassName=request.data['name']
            subClassName=subClassName.upper()
            
            inx=school_sub_class.objects.values().filter(name=subClassName)
            x=0
            #[x, msg]=newUser.lookIfMobileNoExists(mobileNumber)
            
            if x==0:
                inv=school_sub_class(
                    school_class_id=schoolClassId,
                    name=subClassName,
                    status= 'Active',
                    )
                
                inv.save()
                
                #[idx, msg]=newUser.getStudentIdUsingStudentDetails( firstName, middleName, lastName, firstMobileNumber, secondMobileNumber)

               
                """
                
                """
                msg="Class Stream was successfully created"

            else:
                 msg="A user with similar mobile numbers has already been created"
            """
            id = models.BigAutoField(primary_key=True)
            ward=models.ForeignKey(district, on_delete=models.CASCADE)
            status=models.CharField(max_length=32)
            name=models.CharField(max_length=128)
            school_code=models.CharField(max_length=16, default="")
            street=models.CharField(max_length=32)
            plot_number=models.CharField(max_length=32)
            area_details=models.CharField(max_length=128)
            telephone_number_1=models.CharField(max_length=16)
            telephone_number_2=models.CharField(max_length=16)
            email=models.CharField(max_length=128)
            website=models.CharField(max_length=128)
            """
            #print("123")
            ### 
            
            #msg="School was successfully created"
            """    """
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #
        return Response({ 'status': str(status.HTTP_201_CREATED), 'msg': msg, 'datax': datax})





class DeleteSchoolSubClassView(APIView):
    serializer_class= SchoolSubClassDetailsSerializer 
    #UsersDetailsSerializer#SchoolSubClassDetailsSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print(" xdatax =" + str(request.data))
        datax=str(request.data)
        idx=0
        msg=""
        try:
            """
            """
            idx=0
            schoolSubClassId=0
            schoolSubClassId=request.data['id']
            #subClassName=request.data['name']
            x=0
            #[x, msg]=newUser.lookIfMobileNoExists(mobileNumber)
            
            if x==0:
                inv=school_sub_class.objects.values().filter(
                    id=schoolSubClassId,
                    status= 'Active',
                    ).update(status='InActive')
                
                #inv.save()
                
                #[idx, msg]=newUser.getStudentIdUsingStudentDetails( firstName, middleName, lastName, firstMobileNumber, secondMobileNumber)

               
                """
                
                """
                msg="Class Stream was successfully deleted"

            else:
                 msg="A user with similar mobile numbers has already been created"
            """
            id = models.BigAutoField(primary_key=True)
            ward=models.ForeignKey(district, on_delete=models.CASCADE)
            status=models.CharField(max_length=32)
            name=models.CharField(max_length=128)
            school_code=models.CharField(max_length=16, default="")
            street=models.CharField(max_length=32)
            plot_number=models.CharField(max_length=32)
            area_details=models.CharField(max_length=128)
            telephone_number_1=models.CharField(max_length=16)
            telephone_number_2=models.CharField(max_length=16)
            email=models.CharField(max_length=128)
            website=models.CharField(max_length=128)
            """
            #print("123")
            ### 
            
            #msg="School was successfully created"
            """    """
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #
        return Response({ 'status': str(status.HTTP_201_CREATED), 'msg': msg, 'datax': datax})



class CreateExamSubjectsView(APIView):
    serializer_class= ExamSubjectsSerializer 
    #ExamSubjectsSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        datax=str(request.data)
        idx=0
        msg=""
        try:
            """
            """
            idx=0
            examsId=0
            examsId=request.data['exams']

            schoolSubClassId=0
            schoolSubClassId=request.data['school_sub_class']

            subjectsId=0
            subjectsId=request.data['subjects']
            
            x=0
            
            if x==0:
                inx=exams_subject.objects.values().filter(
                    exams_id=examsId,
                    school_sub_class_id=schoolSubClassId,
                    subjects_id=subjectsId,
                    status= 'Active',
                    ).update(status='InActive')
                inv=exams_subject(
                    exams_id=examsId,
                    school_sub_class_id=schoolSubClassId,
                    subjects_id=subjectsId,
                    status= 'Active',
                    )
                
                inv.save()
                
                #[idx, msg]=newUser.getStudentIdUsingStudentDetails( firstName, middleName, lastName, firstMobileNumber, secondMobileNumber)

               
                """
                
                """
                msg="Exam subjects was successfully created"

            else:
                 msg="A user with similar mobile numbers has already been created"
            """
            id = models.BigAutoField(primary_key=True)
            ward=models.ForeignKey(district, on_delete=models.CASCADE)
            status=models.CharField(max_length=32)
            name=models.CharField(max_length=128)
            school_code=models.CharField(max_length=16, default="")
            street=models.CharField(max_length=32)
            plot_number=models.CharField(max_length=32)
            area_details=models.CharField(max_length=128)
            telephone_number_1=models.CharField(max_length=16)
            telephone_number_2=models.CharField(max_length=16)
            email=models.CharField(max_length=128)
            website=models.CharField(max_length=128)
            """
            #print("123")
            ### 
            
            #msg="School was successfully created"
            """    """
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #
        return Response({ 'status': str(status.HTTP_201_CREATED), 'msg': msg, 'datax': datax})







class DeleteExamSubjectsView(APIView):
    serializer_class= ExamSubjectsSerializer 
    #ExamSubjectsSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        datax=str(request.data)
        idx=0
        msg=""
        try:
            """
            """
            idx=0
            examsId=0
            examsId=request.data['exams']

            schoolSubClassId=0
            schoolSubClassId=request.data['school_sub_class']

            subjectsId=0
            subjectsId=request.data['subjects']
            
            x=0
            
            if x==0:
                inx=exams_subject.objects.values().filter(
                    exams_id=examsId,
                    school_sub_class_id=schoolSubClassId,
                    subjects_id=subjectsId,
                    status= 'Active',
                    ).update(status='InActive')
               
                
                #[idx, msg]=newUser.getStudentIdUsingStudentDetails( firstName, middleName, lastName, firstMobileNumber, secondMobileNumber)

               
                """
                
                """
                msg="Exam subjects was successfully deleted"

            else:
                 msg="A user with similar mobile numbers has already been created"
            """
            id = models.BigAutoField(primary_key=True)
            ward=models.ForeignKey(district, on_delete=models.CASCADE)
            status=models.CharField(max_length=32)
            name=models.CharField(max_length=128)
            school_code=models.CharField(max_length=16, default="")
            street=models.CharField(max_length=32)
            plot_number=models.CharField(max_length=32)
            area_details=models.CharField(max_length=128)
            telephone_number_1=models.CharField(max_length=16)
            telephone_number_2=models.CharField(max_length=16)
            email=models.CharField(max_length=128)
            website=models.CharField(max_length=128)
            """
            #print("123")
            ### 
            
            #msg="School was successfully created"
            """    """
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #
        return Response({ 'status': str(status.HTTP_201_CREATED), 'msg': msg, 'datax': datax})




class CopyExamSubjectsToAnotherStreamView(APIView):
    serializer_class= ExamSubjectsSerializer 
    #ExamSubjectsSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        datax=str(request.data)
        idx=0
        msg=""
        try:
            """
            """
            idx=0
            examsId=0
            examsId=request.data['exams']

            schoolSubClassId=0
            schoolSubClassId=request.data['school_sub_class']

            subjectsId=0
            subjectsId=request.data['subjects']
            
            newStreamId=subjectsId
            
            x=0
            subjectsId=0
            
            print("copy from subclass=" + str(schoolSubClassId) + ", newsubclass=" + str(newStreamId))
            if x==0:
                inx=exams_subject.objects.values().filter(
                    exams_id=examsId,
                    school_sub_class_id=schoolSubClassId,
                    status= 'Active',
                    )
               
                for aa in inx:
                     subjectsId=aa['subjects_id']

                     invx=exams_subject.objects.values().filter(
                     exams_id=examsId,
                     school_sub_class_id=newStreamId,
                     status= 'Active',   
                     subjects_id=subjectsId
                     ).update(status= 'InActive')
                     
                     inv=exams_subject(
                     exams_id=examsId,
                     school_sub_class_id=newStreamId,
                     status= 'Active',   
                     subjects_id=subjectsId
                     )
                     inv.save()
                #[idx, msg]=newUser.getStudentIdUsingStudentDetails( firstName, middleName, lastName, firstMobileNumber, secondMobileNumber)

               
                """
                
                """
                msg="Exam subjects was successfully copied"

            else:
                 msg="A user with similar mobile numbers has already been created"
            """
            id = models.BigAutoField(primary_key=True)
            ward=models.ForeignKey(district, on_delete=models.CASCADE)
            status=models.CharField(max_length=32)
            name=models.CharField(max_length=128)
            school_code=models.CharField(max_length=16, default="")
            street=models.CharField(max_length=32)
            plot_number=models.CharField(max_length=32)
            area_details=models.CharField(max_length=128)
            telephone_number_1=models.CharField(max_length=16)
            telephone_number_2=models.CharField(max_length=16)
            email=models.CharField(max_length=128)
            website=models.CharField(max_length=128)
            """
            #print("123")
            ### 
            
            #msg="School was successfully created"
            """    """
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #
        return Response({ 'status': str(status.HTTP_201_CREATED), 'msg': msg, 'datax': datax})






class CopyStudentsToAnotherStreamView(APIView):
    serializer_class= StudentSubClassToCopySerializer
    #ExamSubjectsSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        datax=str(request.data)
        idx=0
        msg=""
        try:
            """
            """
            idx=0
            schoolId=0
            schoolId=request.data['status']
            
            newSubClassId=0
            newSubClassId=request.data['student']
            
            newAcademicYearId=0
            newAcademicYearId=request.data['id']
            

            oldSubClassId=0
            oldSubClassId=request.data['school_sub_class']
            
            oldAcademicYearId=0
            oldAcademicYearId=request.data['academic_year']
            #student
            
            x=0
            print("copy from subclass=" + str(oldSubClassId) + ", newsubclass=" + str(newSubClassId))
            studentId=0

            if x==0:
                inx=student_sub_class.objects.values().filter(
                    academic_year_id=newAcademicYearId,
                    school_sub_class_id=oldSubClassId,
                    status= 'Active',
                    )
               
                for aa in inx:
                     
                     studentId=aa['student_id']
                     statusx="TR <F: S" + oldSubClassId +  "," + oldAcademicYearId + "> T<" + newSubClassId + "," + newAcademicYearId + ">"
                    
                     invx=student_sub_class.objects.values().filter(
                     id=aa['id'],
                     status= 'Active',  
                     ).update(status=statusx )
                     
                     ###student   school_sub_class
                     inv=student_sub_class(
                     student_id=studentId,
                     school_sub_class_id=newSubClassId,
                     status= 'Active',   
                     academic_year_id=newAcademicYearId
                     )
                     inv.save()
                #[idx, msg]=newUser.getStudentIdUsingStudentDetails( firstName, middleName, lastName, firstMobileNumber, secondMobileNumber)

               
                """
                
                """
                msg="Students were successfully copied to another stream"

            else:
                 msg="A user with similar mobile numbers has already been created"
            """
            id = models.BigAutoField(primary_key=True)
            ward=models.ForeignKey(district, on_delete=models.CASCADE)
            status=models.CharField(max_length=32)
            name=models.CharField(max_length=128)
            school_code=models.CharField(max_length=16, default="")
            street=models.CharField(max_length=32)
            plot_number=models.CharField(max_length=32)
            area_details=models.CharField(max_length=128)
            telephone_number_1=models.CharField(max_length=16)
            telephone_number_2=models.CharField(max_length=16)
            email=models.CharField(max_length=128)
            website=models.CharField(max_length=128)
            """
            #print("123")
            ### 
            
            #msg="School was successfully created"
            """    """
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #
        return Response({ 'status': str(status.HTTP_201_CREATED), 'msg': msg, 'datax': datax})


class StudentExamScoreView(APIView):
    serializer_class= StudentExamScoreSerializer
    #ExamSubjectsSerializer  StudentExamScoreSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        datax=str(request.data)
        idx=0
        msg=""
        try:
            """
            """
            idx=0
            examsId=0
            examsId=request.data['exams']

            schoolStudentId=0
            schoolStudentId=request.data['school_student']

            examsSubjectId=0
            examsSubjectId=request.data['exams_subject']
            
            score=0
            score=request.data['score']
            
            x=0

            inx=student_exam_score.objects.values().filter(exams_id=examsId,
                    school_student_id=schoolStudentId,
                    exams_subject_id=examsSubjectId,
                    status='Active').update(
                    status= 'InActive',
                    )
            
            if x==0:
                inv=student_exam_score(
                    exams_id=examsId,
                    school_student_id=schoolStudentId,
                    exams_subject_id=examsSubjectId,
                    score=score,
                    status= 'Active',
                    )
                
                inv.save()
                
                #[idx, msg]=newUser.getStudentIdUsingStudentDetails( firstName, middleName, lastName, firstMobileNumber, secondMobileNumber)

               
                """
                
                """
                msg="Exam score was successfully created"

            else:
                 msg="A user with similar mobile numbers has already been created"
            """
            id = models.BigAutoField(primary_key=True)
            ward=models.ForeignKey(district, on_delete=models.CASCADE)
            status=models.CharField(max_length=32)
            name=models.CharField(max_length=128)
            school_code=models.CharField(max_length=16, default="")
            street=models.CharField(max_length=32)
            plot_number=models.CharField(max_length=32)
            area_details=models.CharField(max_length=128)
            telephone_number_1=models.CharField(max_length=16)
            telephone_number_2=models.CharField(max_length=16)
            email=models.CharField(max_length=128)
            website=models.CharField(max_length=128)
            """
            #print("123")
            ### 
            
            #msg="School was successfully created"
            """    """
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #
        return Response({ 'status': str(status.HTTP_201_CREATED), 'msg': msg, 'datax': datax})



class UserLoginView(APIView):
    serializer_class= UsersDetailsSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        datax=str(request.data)
        fullName=""
        loginCategoryName=''
        usersId=0
        idx=0
        msg=""
        qr=""
        loginCategory=""
        loginCategoryId=0
        mobileNo=""
        userPassword=""
        details=""
        x=0
        schoolId=0
        schoolName=""
        msgy=""
        schoolDetails=""

        try:
            
            mobileNumber=request.data['mobile_number']
            userPassword=request.data['user_password']
           
            inv=view_v_user_details_1_a.objects.values().filter(mobile_number=mobileNumber, user_password=userPassword)
            #inv.save()

            #ixc=users.objects.values().filter(mobile_number=mobileNumber, 
            fullName=''
            loginCategoryName=''
            usersId=0
            for ab in inv:
                    fullName=ab['full_name']
                    loginCategoryName=ab['login_category_name']
                    usersId=ab['users_id']
                    loginCategoryId=ab['login_category_id']

            ###
            #getUserSchoolNameUsingUserId(userId)     [schoolId, schoolName, msg]
            if loginCategoryName=="Administrator":
                 schoolDetails={ "schoolId": schoolId, "schoolName": "All schools", "msgy": msgy}
            else:
                 [schoolId, schoolName, msgy]=newUser.getUserSchoolNameUsingUserId(usersId)
                 schoolDetails={ "schoolId": schoolId, "schoolName": schoolName, "msgy": msgy}
                 
                 
            ###
            print ("usersId=" + str(usersId))
            if usersId==0:
                msg="User login failed"
            elif usersId>0:
                msg="User login was successful"
            else:
                msg=''
            
            #""" """
            
            #qr=view_v_user_roles_1_a.objects.values().filter(users_id=usersId)
            #qr=list(qr)
            
            loginCategory=""
            avn=view_v_user_details_1_a.objects.values().filter(users_id=usersId)
            for xa in avn:
                #
                loginCategory=xa['login_category_name']
                mobileNo=xa['mobile_number']
                userPassword=xa['user_password']
                
                details={
                  "loginCategory": loginCategory,
                  "mobileNo": mobileNo,
                  "userPassword": userPassword,
                  "fullName": fullName,
                  "usersId": usersId,
                  "loginCategoryId": loginCategoryId,
                }
                
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #return Response('', status=status.HTTP_201_CREATED)
        #return Response(CreateUsersSerializer(inv).data, status=status.HTTP_201_CREATED)
        #print("user_id=" + str(idx) + ", " +  str(""))
        return Response({'userId': usersId, 'status': str(status.HTTP_201_CREATED), 'msg': msg, 
            'fullName': fullName, 
            'loginCategoryName': str(loginCategoryName),
            'qr': qr,
            'mobileNo': mobileNo,
            'userPassword': userPassword,
            'loginCategory': loginCategory,
             'loginDetails': details,
             'schoolDetails': schoolDetails,
        })

 #""" """


 
class SchoolAdminsView(APIView):
    serializer_class=SchoolAdminsDetailsSerializer ###UsersDetailsSerializer

    def get(self, request, format=None):
        queryset=''
        try:
            
            queryset=view_v_gg_school_admins_details_1_a.objects.values().filter(login_category_name='School Administrator')
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= SchoolAdminsDetailsSerializer
            serializer= SchoolAdminsDetailsSerializer(view_v_gg_school_admins_details_1_a, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)
    



 
class SchoolTeachersView(APIView):
    serializer_class=SchoolAdminsDetailsSerializer ###UsersDetailsSerializer

    def get(self, request, format=None):
        queryset=''
        try:
            
            queryset=view_v_gg_school_admins_details_1_a.objects.values().filter(login_category_name='School Teacher')
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= SchoolAdminsDetailsSerializer
            serializer= SchoolAdminsDetailsSerializer(view_v_gg_school_admins_details_1_a, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)
    

     
class SchoolSubClassView(APIView):
    #                 SchoolSubClassDetailsSerializer
    serializer_class= SchoolSubClassDetailsSerializer
    
    def get(self, request, format=None):
        queryset=''
        try:
            
            queryset=school_sub_class.objects.values().filter(status='Active')
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= SchoolSubClassDetailsSerializer
            serializer= SchoolSubClassDetailsSerializer(school_sub_class, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)
    


     
class SingleTeacherExamSubjectsViewEXT(APIView):
    #                 SchoolSubClassDetailsSerializer
    serializer_class= SingleTeacherExamSubjectsSerializer
    
    def get(self, request, schoolId, usersId, examsId, format=None):
        queryset=''
        bList=[]
        try:
            
            queryset=view_v_hj_teachers_exam_subjects_details_1_a.objects.values().filter(
                 school_id=schoolId, users_id=usersId, exams_id=examsId)
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= SingleTeacherExamSubjectsSerializer
            serializer= SingleTeacherExamSubjectsSerializer(view_v_hj_teachers_exam_subjects_details_1_a, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)
    

class SingleTeacherExamSubjectsView(APIView):
    #                 SchoolSubClassDetailsSerializer
    serializer_class= SingleTeacherExamSubjectsSerializer
    
    def get(self, request, schoolId, usersId, examsId, format=None):
        queryset=''
        bList=[]
        try:
            
            queryset=view_v_hj_teachers_exam_subjects_details_1_a.objects.values().filter(
                 school_id=schoolId, users_id=usersId, exams_id=examsId)
            #view_v_user_details_1_a
            aList=list(queryset)
            bList=[]
            
            subClassId=0
            for aa in aList:
                 xx=0
                 subjectId=aa['subject_id']
                 for bb in bList:
                      if bb['subject_id']==aa['subject_id']:
                           xx=1
                      
                 if xx==0:
                      bList.append({
                           'exam_subject_id': aa['exam_subject_id'],
                           'subject_id': aa['subject_id'],
                           'subject_name': aa['subject_name'],
                      })
                 
            print("queryset=" + str(queryset))
            serializer_class= SingleTeacherExamSubjectsSerializer
            serializer= SingleTeacherExamSubjectsSerializer(view_v_hj_teachers_exam_subjects_details_1_a, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(bList)
    


class SingleTeacherExamSubClassView(APIView):
    #                 SchoolSubClassDetailsSerializer
    serializer_class= SingleTeacherExamSubjectsSerializer
    
    def get(self, request, schoolId, usersId, examsId, format=None):
        queryset=''
        bList=[]
        try:
            
            queryset=view_v_hj_teachers_exam_subjects_details_1_a.objects.values().filter(
                 school_id=schoolId, users_id=usersId, exams_id=examsId)#.order_by('')
            
            aList=list(queryset)
            bList=[]
            
            subClassId=0
            for aa in aList:
                 xx=0
                 subClassId=aa['school_sub_class_id']
                 for bb in bList:
                      if bb['school_sub_class_id']==aa['school_sub_class_id']:
                           xx=1
                      
                 if xx==0:
                      bList.append({
                           'exam_subject_id': aa['exam_subject_id'],
                           'school_sub_class_id': aa['school_sub_class_id'],
                           'stream_name': aa['stream_name'],
                      })
                 
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= SingleTeacherExamSubjectsSerializer
            serializer= SingleTeacherExamSubjectsSerializer(view_v_hj_teachers_exam_subjects_details_1_a, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(bList)
    

 
class SingleTeacherExamsView(APIView):
    #                 SchoolSubClassDetailsSerializer
    serializer_class= SingleTeacherExamSubjectsSerializer
    
    def get(self, request, schoolId, usersId, format=None):
        queryset=''
        bList=[]
        try:
            
            queryset=view_v_hj_teachers_exam_subjects_details_1_a.objects.values().filter(
                 school_id=schoolId, users_id=usersId)
            
            
            aList=list(queryset)
            bList=[]
            
            subClassId=0
            for aa in aList:
                 xx=0
                 #subClassId=aa['school_sub_class_id']
                 for bb in bList:
                      if bb['exams_id']==aa['exams_id']:
                           xx=1
                      
                 if xx==0:
                      bList.append({
                           'exam_subject_id': aa['exam_subject_id'],
                           'exams_id': aa['exams_id'],
                           'exams_name': aa['exams_name'],
                      })
                 
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= SingleTeacherExamSubjectsSerializer
            serializer= SingleTeacherExamSubjectsSerializer(view_v_hj_teachers_exam_subjects_details_1_a, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(bList)
    




class SingleSchoolExamsUsingSchoolIdView(APIView):
    #                 SchoolSubClassDetailsSerializer
    serializer_class= SingleTeacherExamSubjectsSerializer
    
    def get(self, request, schoolId, format=None):
        queryset=''
        bList=[]
        try:
            
            queryset=exams.objects.values().filter(
                 school_id=schoolId, status='Active')
            
            
            aList=list(queryset)
            bList=[]
            
            subClassId=0
            for aa in aList:
                 xx=0
                 #subClassId=aa['school_sub_class_id']
                 for bb in bList:
                      if bb['exams_id']==aa['id']:
                           xx=1
                      
                 if xx==0:
                      bList.append({
                           'exams_id': aa['id'],
                           'exams_name': aa['name'],
                      })
                 
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= SingleTeacherExamSubjectsSerializer
            serializer= SingleTeacherExamSubjectsSerializer(exams, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(bList)
    




class SingleSchoolExamsUsingSchoolIdViewEXT1(APIView):
    #                 SchoolSubClassDetailsSerializer
    serializer_class= SingleTeacherExamSubjectsSerializer
    
    def get(self, request, schoolId, format=None):
        queryset=''
        bList=[]
        try:
            
            queryset=exams.objects.values().filter(
                 school_id=schoolId, status='Active')
            
            
            aList=list(queryset)
            bList=[]
            
            subClassId=0
            for aa in aList:
                 xx=0
                 #subClassId=aa['school_sub_class_id']
                 for bb in bList:
                      if bb['exams_id']==aa['id']:
                           xx=1
                      
                 if xx==0:
                      bList.append({
                           'exams_id': aa['id'],
                           'exams_name': aa['name'],
                      })
                 
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= SingleTeacherExamSubjectsSerializer
            serializer= SingleTeacherExamSubjectsSerializer(exams, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(bList)
    




     
class SingleSchoolSubClassView(APIView):
    #                 SchoolSubClassDetailsSerializer
    serializer_class= SchoolSubClassDetailsSerializer
    
    def get(self, request, schoolId, format=None):
        queryset=''
        try:
            
            queryset=view_v_ff_school_sub_class_details_1_a.objects.values().filter(sub_class_status='Active', school_id=schoolId)
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= SchoolSubClassDetailsSerializer
            serializer= SchoolSubClassDetailsSerializer(view_v_ff_school_sub_class_details_1_a, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)



 
class SingleSchoolSubClassUsingClassView(APIView):
    #                 SchoolSubClassDetailsSerializer
    serializer_class= SingleSchoolSubClassDetailsSerializer
    
    def get(self, request, schoolId, classId, format=None):
        queryset=''
        try:
            
            queryset=view_v_ff_school_sub_class_details_1_a.objects.values().filter(
                 sub_class_status='Active', 
                 school_id=schoolId,
                 class_id=classId
                 )
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= SingleSchoolSubClassDetailsSerializer
            serializer= SingleSchoolSubClassDetailsSerializer(view_v_ff_school_sub_class_details_1_a, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)
    

class AcademicYearView(APIView):
    #                 SchoolSubClassDetailsSerializer
    serializer_class= AcademicYearDetailsSerializer
    
    def get(self, request, format=None):
        queryset=''
        try:
            
            queryset=academic_year.objects.values().filter(status='Active')
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= AcademicYearDetailsSerializer
            serializer= AcademicYearDetailsSerializer(academic_year, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)
    

###   StudentsDetailsSerializer


class SubjectsView(APIView):
    #                 SchoolSubClassDetailsSerializer
    serializer_class= SubjectsDetailsSerializer
    
    def get(self, request, format=None):
        queryset=''
        try:
            
            queryset=subjects.objects.values().filter(status='Active')
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= SubjectsDetailsSerializer
            serializer= SubjectsDetailsSerializer(subjects, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)
    



class AllStudentsView(APIView):
    #                 SchoolSubClassDetailsSerializer
    serializer_class= StudentsDetailsSerializer
    
    def get(self, request, format=None):
        queryset=''
        try:
            
            queryset=view_v_aa_student_details_1_a.objects.values().filter()
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= StudentsDetailsSerializer
            serializer= StudentsDetailsSerializer(view_v_aa_student_details_1_a, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)



class AllStudentsWithSubClassesView(APIView):
    #                 StudentsWithSubClassesDetailsSerializer
    serializer_class= StudentsWithSubClassesDetailsSerializer
    
    def get(self, request,schoolId, format=None):
        queryset=''
        try:
            
            queryset=view_v_ab_student_details_1_a.objects.values().filter(school_id=schoolId)
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= StudentsDetailsSerializer
            serializer= StudentsDetailsSerializer(view_v_aa_student_details_1_a, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)






class SubClassStudentsUsingSubClassAndAcademicYearView(APIView):
    #                 StudentsWithSubClassesDetailsSerializer
    serializer_class= StudentsWithSubClassesDetailsSerializer
    
    def get(self, request,schoolId, subClassId, academicYearId, format=None):
        queryset=''
        try:
            
            queryset=view_v_ab_student_details_1_a.objects.values().filter(
                 school_id=schoolId,
                 sub_class_id=subClassId,
                 academic_year_id=academicYearId
                 )
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= StudentsDetailsSerializer
            serializer= StudentsDetailsSerializer(view_v_aa_student_details_1_a, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)




class SubClassFullExamResultsView(APIView):
    #                 StudentsWithSubClassesDetailsSerializer
    serializer_class= StudentsWithSubClassesDetailsSerializer
    
    def get(self, request, schoolId, examsId, subClassId, academicYearId, format=None):
        queryset=''
        try:
            xy=0
            xdict={}
            totalScore=float(0.0)
            numberOfSubjects=0
            iList=[]
            xList=[]
            yList=[]
            invx=exams_subject.objects.values().filter(
                 school_sub_class_id=subClassId,
                 exams_id=subClassId,
                 status='Active'
                 ).order_by('subjects_id')
            
            ##
            #for aa in invx:
            numberOfSubjects=newExams.getNumberOfSubjects(examsId, subClassId)
            studentId=0
            subjectId=0
            examsScore=0.0
            subjectName=""
            studentName=""
            averageScore=0
            
            invx=student_sub_class.objects.values().filter(
                      school_sub_class=subClassId, 
                      academic_year= academicYearId,
                      status='Active'
                 )

            for aa in invx:
                 xy=xy+1
                 xdict={}
                 totalScore=float(0.0)
                 studentId=aa['student_id']
                 studentName=newUser.getStudentNameUsingStudentId(studentId)
                 print("studentName=" + studentName)
                 print("studentId=" + str(studentId))
                 xdict["studentName"] = studentName
                 xdict["studentId"] = studentId
                 xdict["id"] = studentId

                 invy=exams_subject.objects.values().filter(
                 school_sub_class_id=subClassId,
                 exams_id=examsId,
                 status='Active'
                 ).order_by('subjects_id')
                 
                 #xList=[]
                 # examsC
                 for bb in invy:
                      subjectId=bb['subjects_id']
                      examsScore=newExams.getExamsScore(examsId, subjectId, studentId)
                      totalScore+=float(examsScore)
                      subjectName=newExams.getExamsSubject(subjectId)
                      #xList.append({ 'subjectName': subjectName, 'score': examsScore, })
                      xdict["" + subjectName + ""] = str(examsScore)
                 ###
                 xdict["totalScore"] = str(totalScore)
                 averageScore=float(totalScore)/float(numberOfSubjects)
                 xdict["averageScore"] = str(averageScore)
                 xdict["id"] = str(xy)
                 #xdict["subjectsAndScores"] = xList
                 #numberOfSubjects import json
                 print("iop= " + str(xdict))
                 xList.append(xdict)
                 xdict=json.dumps(xdict)
                 iList.append(xdict)
                 
            xList=newExams.sortListOfResultsUsingAverageScore(xList)  
            yList=[]  
            for a in xList:
                 yList.append(json.dumps(a))
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= StudentsDetailsSerializer
            serializer= StudentsDetailsSerializer(view_v_aa_student_details_1_a, many=True)
            
        except Exception as e:
                    print("error ty56 except=" + str(e))
        return Response(yList)






class SingleStudentFullExamResultsView(APIView):
    #                 StudentsWithSubClassesDetailsSerializer
    serializer_class= StudentsWithSubClassesDetailsSerializer
    
    def get(self, request, schoolId, examsId, subClassId, academicYearId, studentId, format=None):
        queryset=''
        try:
            xy=0
            xdict={}
            totalScore=float(0.0)
            numberOfSubjects=0
            iList=[]
            xList=[]
            yList=[]
            scoresList=[]
            invx=exams_subject.objects.values().filter(
                 school_sub_class_id=subClassId,
                 exams_id=examsId,
                 status='Active'
                 ).order_by('subjects_id')
            
            ##
            #for aa in invx:
            numberOfSubjects=newExams.getNumberOfSubjects(examsId, subClassId)
            #studentId=0
            subjectId=0
            examsScore=0.0
            subjectName=""
            studentName=""
            averageScore=0
            
            print("numberOfSubjects=" + str(numberOfSubjects))
            print("subClassId=" + str(subClassId))
            print("academicYearId=" + str(academicYearId))
            print("studentId=" + str(studentId))
            
            invx=student_sub_class.objects.values().filter(
                      school_sub_class=subClassId, 
                      academic_year= academicYearId,
                      student_id=studentId,
                      status='Active'
                 )
            
            print("invx=" + str(invx))

            for aa in invx:
                 xy=xy+1
                 xdict={}
                 totalScore=float(0.0)
                 studentId=aa['student_id']
                 studentName=newUser.getStudentNameUsingStudentId(studentId)
                 print("studentName=" + studentName)
                 print("studentId=" + str(studentId))
                 
                 #xdict["studentName"] = studentName
                 #xdict["studentId"] = studentId
                 #xdict["id"] = studentId

                 invy=exams_subject.objects.values().filter(
                 school_sub_class_id=subClassId,
                 exams_id=examsId,
                 status='Active'
                 ).order_by('subjects_id')
                 
                 scoresList=[]
                 xcounter=1
                 grade=""
                 remarks=""
                 divisionPoints=0
                 gpaPoints=0
                 divList=[]
                 classLevelsId=newExams.getClassLevelsIdUsingSubClassId(subClassId)

                 for bb in invy:
                      subjectId=bb['subjects_id']
                      examsScore=newExams.getExamsScore(examsId, subjectId, studentId)
                      totalScore+=float(examsScore)
                      subjectName=newExams.getExamsSubject(subjectId)
                      [grade, remarks, divisionPoints, gpaPoints]=newExams.getDivPointsGradesAndRemarksScore( subjectId, subClassId, examsScore)
                      print("XC grade=" + grade)
                      positionstr=""
                      x=0
                      y=0
                      [x,y]=newExams.getPositionOfExamsScoreInASubClass(examsId, subjectId, studentId, subClassId)
                      position="" + str(x) + " out of " + str(y)

                      scoresList.append(
                           {
                                'id': str(xcounter), 
                                'subject': subjectName, 
                                'score': str(examsScore),
                                'grade': grade,
                                'remarks': remarks,
                                'divisionPoints': str(divisionPoints),
                                'gpaPoints': str(gpaPoints),
                                'position': position
                            }
                           )
                      
                      divList.append({'id': xcounter ,'subject': subjectName, 'divisionPoints': divisionPoints})
                      
                      xcounter+=1
                      
                 ###

                 xdict["totalScore"] = str(totalScore)
                 averageScore=float(totalScore)/float(numberOfSubjects)
                 
                 totalDivisionPoints=0
                 totalDivisionPoints=newExams.calculateDivisionPoints(divList, classLevelsId)
                 avgPosition=""
                 x=0
                 y=0
                 [y,x]=newExams.getPositionOfExamsAverageScoreInASubClass( examsId, subClassId, academicYearId, studentId )
                 avgPosition="" + str(y) + " out of " + str(x)
                 scoresList.append({'id': str(xcounter+1), 'subject': 'Total', 'score': str(totalScore), 'grade': '-', 'remarks': '-', 'divisionPoints': '-', 'position': avgPosition })
                 scoresList.append({'id': str(xcounter+2), 'subject': 'Average', 'score': str(averageScore), 'grade': '-', 'remarks': '-', 'divisionPoints': totalDivisionPoints, 'position': avgPosition})
                 
                 iList=scoresList
                 
                 
            #xList=newExams.sortListOfResultsUsingAverageScore(xList)  
            yList=[]  
            
            print("iList=" + str(iList))
            serializer_class= StudentsDetailsSerializer
            serializer= StudentsDetailsSerializer(view_v_aa_student_details_1_a, many=True)
            
        except Exception as e:
                    print("error ty56 except=" + str(e))
        return Response(iList)





class SubClassFullExamColumnsView(APIView):
    #                 StudentsWithSubClassesDetailsSerializer
    serializer_class= StudentsWithSubClassesDetailsSerializer
    
    def get(self, request, examsId, subClassId, format=None):
        queryset=''
        try:
            xdict={}
            totalScore=float(0.0)
            numberOfSubjects=0
            iList=[]
            
            invx=exams_subject.objects.values().filter(
                 school_sub_class_id=subClassId,
                 exams_id=examsId,
                 status='Active'
                 ).order_by('subjects_id')
            
            subjectName=""
            subjectId=0

            for aa in invx:
                 subjectId=aa['subjects_id']
                 subjectName=newExams.getExamsSubject(subjectId)
                 xdict={
                      'subject_id': aa['subjects_id'],
                      'subject_name':  subjectName,
                 }
                 iList.append(xdict)
            ##
            #for aa in invx:
            
            
                 
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= StudentsDetailsSerializer
            serializer= StudentsDetailsSerializer(view_v_aa_student_details_1_a, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(iList)




class SchoolStudentsView(APIView):
    #                 SchoolSubClassDetailsSerializer
    serializer_class= StudentsDetailsSerializer
    
    def get(self, request, schoolId, format=None,):
        queryset=''
        try:
            
            queryset=view_v_aa_student_details_1_a.objects.values().filter(
                 school_id=schoolId)
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= StudentsDetailsSerializer
            serializer= StudentsDetailsSerializer(view_v_aa_student_details_1_a, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)



class ClassLevelsView(APIView):
    #                 SchoolSubClassDetailsSerializer
    serializer_class= ClassLevelsSerializer
    
    def get(self, request, format=None):
        queryset=''
        try:
            
            queryset=class_levels.objects.values().filter(status='Active')
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= ClassLevelsSerializer
            serializer= ClassLevelsSerializer(class_levels, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)
    



class SchoolExamsView(APIView):
    #                 SchoolExamsSerializer
    serializer_class= SchoolExamsSerializer
    
    def get(self, request, format=None):
        queryset=''
        try:
            
            queryset=exams.objects.values().filter(status='Active')
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= SchoolExamsSerializer
            serializer= SchoolExamsSerializer(exams, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)



class SingleSchoolExamsView(APIView):
    #                 SchoolExamsSerializer
    serializer_class= SingleSchoolExamsSerializer
    
    def get(self, request, schoolId, academicYearId, classLevelsId, format=None):
        queryset=''
        try:
            
            queryset=view_v_dd_exams_details_1_a.objects.values().filter(
                 academic_year_id=academicYearId, 
                 school_id=schoolId,
                 class_levels_id=classLevelsId
                 )
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= SchoolExamsSerializer
            serializer= SchoolExamsSerializer(exams, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)




class ExamSubjectsView(APIView):
    #                 ExamSubjectsSerializer ExamSubjectsView   view_v_dd_school_exam_subjects_1_a
    serializer_class= ExamSubjectsSerializer
    
    def get(self, request, format=None):
        queryset=''
        try:
            
            queryset=view_v_dd_school_exam_subjects_1_a.objects.values().filter()
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= ExamSubjectsSerializer
            serializer= ExamSubjectsSerializer(exams, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)




class ExamSubjectsUsingSchoolIdView(APIView):
    #                 ExamSubjectsSerializer ExamSubjectsView   view_v_dd_school_exam_subjects_1_a
    serializer_class= ExamSubjectsSerializer
    
    def get(self, request, schoolId, format=None):
        queryset=''
        try:
            
            queryset=view_v_dd_school_exam_subjects_1_a.objects.values().filter(school_id=schoolId).order_by(
                 'exams_id', 'school_sub_class_id')
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= ExamSubjectsSerializer
            serializer= ExamSubjectsSerializer(exams, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)
    




class ExamSubjectsUsingSchoolIdAndExamsIdAndSubjectIdView(APIView):
    #                 ExamSubjectsSerializer ExamSubjectsView   view_v_dd_school_exam_subjects_1_a
    serializer_class= ExamSubjectsSerializer
    
    def get(self, request, schoolId, examsId, subClassId, format=None):
        queryset=''
        try:
            
            queryset=view_v_dd_school_exam_subjects_1_a.objects.values().filter(
                 school_id=schoolId, exams_id=examsId, school_sub_class_id=subClassId).order_by(
                 'exams_id', 'school_sub_class_id')
            #view_v_user_details_1_a
            print("queryset=" + str(queryset))
            serializer_class= ExamSubjectsSerializer
            serializer= ExamSubjectsSerializer(exams, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)
    

class SingleTeacherSubjectsView(APIView):
      def get(self, request, schoolId, usersId, format=None):
        queryset=''
        try:
            queryset=view_v_hh_teacher_subjects_details_1_a.objects.values().filter(
                 school_id=schoolId, users_id=usersId
            )
            print("queryset=" + str(queryset))
            serializer_class= TeachersSubjectsSerializer
            serializer= TeachersSubjectsSerializer(view_v_hh_teacher_subjects_details_1_a,many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)


class SchoolStudentsExamScoreView(APIView):
      def get(self, request, schoolId, subClassId, examsId, subjectId, academicYearId, format=None):
        queryset=''
        try:
            queryset=view_v_nn_students_exam_score_details_1_a.objects.values().filter(
                 school_id=schoolId, school_sub_class_id=subClassId,
                  subjects_id=subjectId, exams_id=examsId,
                  academic_year_id=academicYearId
            )
            print("queryset=" + str(queryset))
            serializer_class= StudentsExamScoreSerializer
            serializer= StudentsExamScoreSerializer(view_v_nn_students_exam_score_details_1_a, many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)






class CreateSingleTeacherSubjectsView(APIView):
    serializer_class= TeachersSubjectsSerializer
    #ExamSubjectsSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        datax=str(request.data)
        idx=0
        msg=""
        try:
            """
            """
            idx=0
            subClassId=0
            subClassId=request.data['sub_class_id']

            #schoolSubClassId=0
            #schoolSubClassId=request.data['school_sub_class']

            subjectsId=0
            subjectsId=request.data['subject_id']
            
            schoolId=0
            schoolId=request.data['school_id']
            
            usersId=0
            usersId=request.data['users_id']
            
            invx=teacher_subjects.objects.values().filter(
                 users_id=usersId, status= 'Active', school_sub_class_id=subClassId, subjects_id=subjectsId,
                    school_id=schoolId).update(
                    status= 'InActive',
                    )
            x=0
            
            if x==0:
                inv=teacher_subjects(
                    users_id=usersId,
                    school_sub_class_id=subClassId,
                    subjects_id=subjectsId,
                    school_id=schoolId,
                    status= 'Active',
                    )
                
                inv.save()
                
                #[idx, msg]=newUser.getStudentIdUsingStudentDetails( firstName, middleName, lastName, firstMobileNumber, secondMobileNumber)

               
                """
                
                """
                msg="Teacher subject was successfully created"

            else:
                 msg="A user with similar mobile numbers has already been created"
            """
            id = models.BigAutoField(primary_key=True)
            ward=models.ForeignKey(district, on_delete=models.CASCADE)
            status=models.CharField(max_length=32)
            name=models.CharField(max_length=128)
            school_code=models.CharField(max_length=16, default="")
            street=models.CharField(max_length=32)
            plot_number=models.CharField(max_length=32)
            area_details=models.CharField(max_length=128)
            telephone_number_1=models.CharField(max_length=16)
            telephone_number_2=models.CharField(max_length=16)
            email=models.CharField(max_length=128)
            website=models.CharField(max_length=128)
            """
            #print("123")
            ### 
            
            #msg="School was successfully created"
            """    """
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #
        return Response({ 'status': str(status.HTTP_201_CREATED), 'msg': msg, 'datax': datax})





class DeleteSingleTeacherSubjectsView(APIView):
    serializer_class= TeachersSubjectsSerializer
    #ExamSubjectsSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        datax=str(request.data)
        idx=0
        msg=""
        try:
            """
            """
            idx=0
            schoolTeacherSubjectsId=0
            schoolTeacherSubjectsId=request.data['school_teacher_subjects_id']

            invx=teacher_subjects.objects.values().filter(
                 id=schoolTeacherSubjectsId, status= 'Active', 
                    ).update(
                    status= 'InActive',
                    )
            x=0
            
            if x==0:
                msg="Teacher subject was successfully updated"

            else:
                 msg="A user with similar mobile numbers has already been created"
            """
            id = models.BigAutoField(primary_key=True)
            ward=models.ForeignKey(district, on_delete=models.CASCADE)
            status=models.CharField(max_length=32)
            name=models.CharField(max_length=128)
            school_code=models.CharField(max_length=16, default="")
            street=models.CharField(max_length=32)
            plot_number=models.CharField(max_length=32)
            area_details=models.CharField(max_length=128)
            telephone_number_1=models.CharField(max_length=16)
            telephone_number_2=models.CharField(max_length=16)
            email=models.CharField(max_length=128)
            website=models.CharField(max_length=128)
            """
            #print("123")
            ### 
            
            #msg="School was successfully created"
            """    """
        except Exception as e:
                print("except=" + str(e))
                msg="error:::" + str(e)
        #
        return Response({ 'status': str(status.HTTP_201_CREATED), 'msg': msg, 'datax': datax})


    