import string
import random

from django.db.models import Q
from datetime import date
from datetime import timedelta
import datetime

import requests
from requests.auth import HTTPBasicAuth

#from numpy import random

import json


#from PIL import Image
from django.http import FileResponse
import os


from school.models import(
    users,
    academic_year,
    student,
    school_parent_credentials_students,
    school_parent_credentials,
    view_v_ab_student_details_d_a,
    organization_school,
    organization,
    view_v_dd_exams_details_1_b,
    view_v_ff_school_sub_class_details_1_a,
    view_v_student_attendance_1_b,
    )
class general:
    
    ###first_mobile_number
    
    def lookIfStudentExists(self, studentsList, studentId):
        x=0
        for a in studentsList:
            if a['studentId']==studentId:
                x=1
        return x
        
    def lookIfParentCredentialsExists(self, parentMobileNo, parentPassword):
        inv=school_parent_credentials.objects.values().filter(mobile_number=parentMobileNo, parent_password=parentPassword, status='Active')
        x=0
        x=len(inv)
        xList=[]
        y=0
        z=0
        studentOne=""
        if x==0:
            x=x
        else:
            ibm=view_v_ab_student_details_d_a.objects.values().filter(first_mobile_number=parentMobileNo, student_status='Active')
            for ab in ibm:
                if y==0:
                    studentOne=ab['full_name']
                
                xdict={
                    "fullName": ab['full_name'],
                    "studentId": ab['student_id'],
                    "schoolId": ab['school_id'],
                    "schoolName": ab['school_name'],
                    "streamName": ab['stream_name'],
                    "subClassId": ab['sub_class_id'],
                    "academicYear": ab['academic_year'],
                    "academicYearId": ab['academic_year_id'],
                }
                
                z=0
                z=self.lookIfStudentExists(xList, ab['student_id'])
                if z==0:
                    xList.append(xdict)
                
                y=y+1
                
            x=x
        strDict={
           "existNumber": x, 
           "students": xList,
           "studentOne": studentOne
        }
        return strDict
        
        
    def getParentsMobileNo(self, studentId):
        ##
        mobileNumber=""
        studentName=""
        inv=student.objects.values().filter(id=studentId, status='Active')
        for x in inv:
            mobileNumber=x['first_mobile_number']
            studentName=x['first_name'] + ' ' + x['middle_name'] + ' ' + x['last_name']
            
        #mobileNumber
        return [mobileNumber, studentName]
    
    
    def getExamDetails(self, examsId, academicYearId, subClassId):
        ##v_dd_exams_details_1_b
        examName=""
        academicYear=""
        streamName=""
        inv=view_v_dd_exams_details_1_b.objects.values().filter(exams_id=examsId, academic_year_id=academicYearId, sub_class_id=subClassId)
        for x in inv:
            examName=x['exams_name']
            academicYear=x['academic_year']
            streamName=x['sub_class_name']
            
        #mobileNumber
        return [examName, academicYear, streamName]
    
    def getStreamAndAcademicYearDetails(self, academicYearId, subClassId):
        ##v_dd_exams_details_1_b
        examName=""
        academicYear=""
        streamName=""
        
        inv=view_v_ff_school_sub_class_details_1_a.objects.values().filter( sub_class_id=subClassId)
        for x in inv:
            #examName=x['exams_name']
            #academicYear=x['academic_year']
            streamName=x['subclass_name']
        
        inx=academic_year.objects.values().filter(id=academicYearId)
        for y in inx:
            #examName=x['exams_name']
            academicYear=y['name']
            #streamName=x['sub_class_name']
        #mobileNumber
        return [academicYear, streamName]
    
    
    def getOrganizationIdUsingSchoolId(self, schoolId):
        ##
        organizationId=0
        organizationName=""
        
        inv=organization_school.objects.values().filter(school_id=schoolId, status='Active')
        for x in inv:
            organizationId=x['organization_id']
            
            
        #mobileNumber
        iny=organization.objects.values().filter(id=organizationId, status='Active')
        for x in iny:
            organizationName=x['name']
            
        
        return [organizationId, organizationName]
       
    def sendMSGToParent(self, mobileNumber, link, msg):
        x=0
        rec=[]
        rec.append( {
            "recipient_id": 1,
            "dest_addr": mobileNumber
        })
        #
        url="https://apisms.beem.africa/v1/send"
        data={
        "source_addr": "ScriptCode",
            "encoding": 0,
            "message": msg,
            "recipients": [
                {
                    "recipient_id": 1,
                    "dest_addr": mobileNumber
                }
            ]
        }
        
        
        username = "79356c6dae01e95d"
        password = "NDQ4ZTE4Y2Y2NjU5MmU0NzI1ZGU1ZmRlZWU5YzdkZTU1YmJiYzE0NjZkOWVjNDY4M2E5NjViM2ZkNThiMzNjMQ=="
        
        response = requests.post(url, json=data, auth=HTTPBasicAuth(username, password))
        
        if response.status_code == 200:
            print("SMS sent successfully!")
        else:
            print("SMS sending failed. Status code:", response.status_code)
            print("Response:", response.text)
                #
        #respCode=respDict['code']
        return response
    
    
    
    def sendMSGToParentold(self, mobileNumber, link, msg):
        x=0
        rec=[]
        rec.append( {
            "recipient_id": 1,
            "dest_addr": mobileNumber
        })
        #
        url="https://messaging-service.co.tz/api/sms/v1/text/single"
        Headers = { 
            'Content-type': 'application/json',
            'Accept': 'application/json',
             'Authorization': 'Basic YW13YXJ1a2E6ZkBEWDhBZmpAU1NNcXdo',
        }
        #myobj = {'somekey': 'somevalue'}
        tinno="174905177"
        myobj={
            "from":"OTP", 
            "to": mobileNumber, 
            "text": msg, 
            "reference": "aswqetgcv"
            }
        
        response = requests.post(url, json = myobj, headers=Headers)
        respText=response.text
        resp=False
        
        print("respText=" + str(respText))
        if response.status_code == 200:
            print("SMS sent successfully!")
            resp=True
        else:
            print("SMS sending failed. Status code:", response.status_code)
            print("Response:", response.text)
            resp=False
        respDict=json.loads(response.text)
        #
        #respCode=respDict['code']
        return resp
    
    
    def getRandomText(self):
        N=17
        res = ''.join(random.choices(string.ascii_lowercase +
                             string.digits, k=N))
        rb=False
        strx=''
        while rb==False:
            #strx=self.lookIfCompanyNoExists(res)
            strx='not exists'
            if strx=='exists':
                rb=False
                res = ''.join(random.choices(string.ascii_lowercase +
                             string.digits, k=N))
            else:
                rb=True
            #strx=self.lookIfCompanyNoExists(res)
        return res
    
    def getParentPassword(self):
        N=5
        res = ''.join(random.choices(string.ascii_lowercase, k=N))
        rb=False
        strx=''
        while rb==False:
            #strx=self.lookIfCompanyNoExists(res)
            strx='not exists'
            if strx=='exists':
                rb=False
                res = ''.join(random.choices(string.ascii_uppercase, k=N))
            else:
                rb=True
            #strx=self.lookIfCompanyNoExists(res)
        return res
    
    def getDateAfterDays(self, numberDays):
        new_date=''
        try:

            current_date = date.today()
            old_date = current_date #+ timedelta(days=-7)
            new_date = current_date + timedelta(days=numberDays)
        except Exception as e:
            print("try catch error A0103: " + str(e))
        return new_date
    
    def convertDateToYMD(self, dateArg):
        dateYMD=''
        try:
            dateYMD=''
            #dDate=datetime.date.today()
            yYear=str(dateArg.year)
            mMonth=str(dateArg.month)
            dDay=str(dateArg.day)
            dateYMD=yYear + '-' + mMonth + '-' + dDay
        except Exception as e:
            print("try catch error A0107: " + str(e))
        
        return dateYMD
    
    def getTodayDate(self):
        todayDateStr=''
        try:
            todayDate=datetime.date.today()
            todayYear=str(datetime.date.today().year)
            todayMonth=str(datetime.date.today().month)
            todayDay=str(datetime.date.today().day)
            if len(todayMonth)==1:
                todayMonth='0' + todayMonth
            if len(todayDay)==1:
                todayDay='0' + todayDay

            todayDateStr= todayYear + '-' + todayMonth + '-' + todayDay
        except Exception as e:
            print("try catch error A0109: " + str(e))
        
        return todayDateStr

    def getTodayTime(self):
        todayTimeStr=''
        try:
            todayTime=datetime.datetime.now()
            todayHour=str(datetime.datetime.now().hour)
            todayMinute=str(datetime.datetime.now().minute)
            todaySecond=str(datetime.datetime.now().second)

            todayTimeStr= todayHour + ':' + todayMinute + ':' + todaySecond + '.000000'
        except Exception as e:
            print("try catch error A0121: " + str(e))
        
        return todayTimeStr
    
    
    
   
    def lookIfMobileNoExists(self, mobileNumber):
        x=0
        msg=""
        try:
            x=x
            ixc=users.objects.values().filter(mobile_number=mobileNumber, status='Active')
            x=len(list(ixc))
            msg="success"
        except Exception as e:
            msg="error failed : " + str(e)
        return [x, msg]
       
    
    
   