from rest_framework import serializers
from school.models import(
school,
view_v_bb_schools_1_a,
city,
district,
ward,
view_v_user_details_1_a,
view_v_gg_school_admins_details_1_a,
view_v_aa_student_details_1_a,
school_class,
school_sub_class,
view_v_cc_school_class_1_a,
academic_year,

student_sub_class,

subjects, exams, class_levels,
exams_subject,
view_v_dd_school_exam_subjects_1_a,
student_exam_score,
view_v_ab_student_details_1_a,
view_v_hh_teacher_subjects_details_1_a,
view_v_nn_students_exam_score_details_1_a,
view_v_hj_teachers_exam_subjects_details_1_a,


)




class CitiesViewSerializer(serializers.ModelSerializer):
    class Meta:
        model=city
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'id',
            'country_id',
            'name',
            'status',
            'code',
        )

class DistrictsViewSerializer(serializers.ModelSerializer):
    class Meta:
        model=district
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'id',
            'city_id',
            'name',
            'status',
            'code',
        )

class WardsViewSerializer(serializers.ModelSerializer):
    class Meta:
        model=ward
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'id',
            'district_id',
            'name',
            'status',
            'code',
        )


class StudentInAStreamSerializer(serializers.ModelSerializer):
    class Meta:
        model=ward
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'id',
            'student',
            'school_sub_class',
            'academic_year',
            'status',
        )

"""
    id = models.BigAutoField(primary_key=True)
    student=models.ForeignKey(student, on_delete=models.CASCADE)
    school_sub_class=models.ForeignKey(school_sub_class, on_delete=models.CASCADE)
    academic_year=models.ForeignKey(academic_year, on_delete=models.CASCADE)
    status=models.CharField(max_length=16)
"""


class SchoolsViewSerializer(serializers.ModelSerializer):
    class Meta:
        model=view_v_bb_schools_1_a
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'school_id',
            'ward_id',
            'school_name',
            'status',
            'school_code',
            'street',
            'plot_number',
            'area_details',
            'telephone_number_1',
            'telephone_number_2',
            'email',
            'website',
        )


class SchoolsViewAllDetailsSerializer(serializers.ModelSerializer):
    class Meta:
        model=view_v_bb_schools_1_a
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'school_id',
            'ward_id',
            'district_id',
            'city_id',
            'ward_name',
            'district_name',
            'city_name',
            'school_name',
            'status',
            'school_code',
            'street',
            'plot_number',
            'area_details',
            'telephone_number_1',
            'telephone_number_2',
            'email',
            'website',
        )


class CreateSchoolsSerializer(serializers.ModelSerializer):
    class Meta:
        model=school
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'ward',
            'name',
            'status',
            'school_code',
            'street',
            'plot_number',
            'area_details',
            'telephone_number_1',
            'telephone_number_2',
            'email',
            'website',
        )
    #company= models.ForeignKey(company, on_delete=models.CASCADE, default="")



class UsersDetailsSerializer(serializers.ModelSerializer):
    class Meta:
        model=view_v_user_details_1_a
        #fields=('name', 'address','telephone', 'status')
        fields=( 
    'users_id',#
    'first_name',#
    'middle_name',#
    'last_name',#
    'full_name',#
    'gender',#
    'mobile_number',#
    'user_email',#
    'date_of_birth',#
    'password_id',#
    'user_password',#
    'login_category_id',#
    'login_category_name',#
        )

    



class SchoolAdminsDetailsSerializer(serializers.ModelSerializer):
    class Meta:
        model=view_v_gg_school_admins_details_1_a
        #fields=('name', 'address','telephone', 'status')
        fields=( 
    'users_id',#
    'first_name',#
    'middle_name',#
    'last_name',#
    'full_name',#
    'gender',#
    'mobile_number',#
    'user_email',#
    'date_of_birth',#
    'password_id',#
    'user_password',#
    'login_category_id',#
    'login_category_name',#
    'school_id',#
    'school_name',#
        )

    


class StudentsDetailsSerializer(serializers.ModelSerializer):
    class Meta:
        model=view_v_aa_student_details_1_a
        #fields=('name', 'address','telephone', 'status')
        fields=( 
    'student_id',#
    'first_name',#
    'middle_name',#
    'last_name',#
    'full_name',#
    'gender',#
    'student_status',#= models.CharField(max_length=16)
    'school_status',#= models.CharField(max_length=16)
    'first_parent_name',#= models.CharField(max_length=64)
    'first_mobile_number',#= models.CharField(max_length=64)
    'second_parent_name',#= models.CharField(max_length=64)
    'second_mobile_number',#= models.CharField(max_length=64)
    'date_of_birth',#=models.DateTimeField(max_length=32, null=True)
    'school_name',#= models.CharField(max_length=64)
        )


class StudentsWithSubClassesDetailsSerializer(serializers.ModelSerializer):
    class Meta:
        model=view_v_ab_student_details_1_a
        #fields=('name', 'address','telephone', 'status')
        fields=( 
    'student_id',#
    'first_name',#
    'middle_name',#
    'last_name',#
    'full_name',#
    'gender',#
    'student_status',#= models.CharField(max_length=16)
    'school_status',#= models.CharField(max_length=16)
    'first_parent_name',#= models.CharField(max_length=64)
    'first_mobile_number',#= models.CharField(max_length=64)
    'second_parent_name',#= models.CharField(max_length=64)
    'second_mobile_number',#= models.CharField(max_length=64)
    'date_of_birth',#=models.DateTimeField(max_length=32, null=True)
    'school_name',#= models.CharField(max_length=64)
    'school_id',#= models.CharField(max_length=64)
    'school_status',#= models.CharField(max_length=16)
    'stream',#= models.CharField(max_length=16)
    'academic_year',#= models.CharField(max_length=16)
        )


class SchoolClassDetailsSerializer(serializers.ModelSerializer):
    class Meta:
        model=school_class
        fields=( 
    'id',
    'name',
    'school',
    'class_levels',
    'status',
    
        )



class SchoolSubClassDetailsSerializer(serializers.ModelSerializer):
    class Meta:
        model=school_sub_class
        fields=( 
    'id',
    'name',
    'school_class',
    'status',
    
        )



class SingleSchoolSubClassDetailsSerializer(serializers.ModelSerializer):
    class Meta:
        model=school_sub_class
        fields=( 
    'id',
    'name',
    'school_class',
    'class_name',
    'class_id',
    
    'status',
    
        )


class AcademicYearDetailsSerializer(serializers.ModelSerializer):
    class Meta:
        model=academic_year
        fields=( 
    'id',
    'name',
    'status',
        )





class SubjectsDetailsSerializer(serializers.ModelSerializer):
    class Meta:
        model=subjects
        fields=( 
    'id',
    'name',
    'status',
        )



class SchoolClassViewDetailsSerializer(serializers.ModelSerializer):
    class Meta:
        model=view_v_cc_school_class_1_a
        fields=( 
    'class_id',
    'class_name',
    'school_id',
    'school_name',
    
        )

class ExamsDetailsSerializer(serializers.ModelSerializer):
    class Meta:
        model=exams
        fields=( 
    'id',
    'school',
    'academic_year',
    'class_levels',
    'name',
    'status'
        )


class ClassLevelsSerializer(serializers.ModelSerializer):
    class Meta:
        model=class_levels
        fields=( 
    'id',
    'name',
    'status'
        )


class SchoolExamsSerializer(serializers.ModelSerializer):
    class Meta:
        model=class_levels
        fields=( 
    'id',
    'school',
    'academic_year',
    'class_levels'
    'name',
    'status',

        )




class SingleSchoolExamsSerializer(serializers.ModelSerializer):
    class Meta:
        model=class_levels
        fields=( 
    'exams_id',
    'academic_year_id',
    'school_id',
    'class_levels_id',
    'exams_name',
    'school_name',
    'academic_year',
    'class_levels_name'
    

        )



class ExamSubjectsSDSerializer(serializers.ModelSerializer):
    class Meta:
        model=exams_subject
        fields=( 
    'id',
    'exams',
    'school_sub_class',
    'subjects',
    'status',

        )


class ExamSubjectsSerializer(serializers.ModelSerializer):
    class Meta:
        model=view_v_dd_school_exam_subjects_1_a
        fields=( 
    'exam_subject_id',
    'exams_id',
    'school_sub_class_id',
    'subject_name',
    'exams_name',

        )




"""
 id = models.BigAutoField(primary_key=True)
    school=models.ForeignKey(school, on_delete=models.CASCADE)
    academic_year=models.ForeignKey(academic_year, on_delete=models.CASCADE)
    class_levels=models.ForeignKey(class_levels, on_delete=models.CASCADE)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=16)
"""


class StudentExamScoreSerializer(serializers.ModelSerializer):
    class Meta:
        model=student_exam_score
        fields=( 
    'id',
    'exams',
    'exams_subject',
    'school_student',
    'score',
    'status',

        )


class TeachersSubjectsSerializer(serializers.ModelSerializer):
    class Meta:
        model=view_v_hh_teacher_subjects_details_1_a
        fields=( 
    'school_teacher_subjects_id',
    'users_id',
    'full_name',
    'school_id',
    'sub_class_id',

    'subclass_name',
    'subject_id',
    'subject_name',

        )


class StudentsExamScoreSerializer(serializers.ModelSerializer):
    class Meta:
        model=view_v_nn_students_exam_score_details_1_a
        fields=( 
    
    'exam_subject_id',# = models.BigAutoField(primary_key=True)
    'student_id',#= models.IntegerField()
    'school_id',#= models.IntegerField()
    'exams_id',#= models.IntegerField()
    'subjects_id',#= models.IntegerField()
    'school_sub_class_id',#= models.IntegerField()
    'academic_year_id',
    
    'school_name',
    'full_name',
    'exams_name',
    'subject_name',
    'stream_name',
    'academic_year',
    'score_ext',
        )




class SingleTeacherExamSubjectsSerializer(serializers.ModelSerializer):
    class Meta:
        model=view_v_hj_teachers_exam_subjects_details_1_a
        fields=( 

    'exam_subject_id',# = models.BigAutoField(primary_key=True) #
    'exams_id',#= models.IntegerField()#
    'class_levels_id',#= models.IntegerField()
    'class_id',#= models.IntegerField() #
    'subject_id',#= models.IntegerField()
    'school_id',#= models.IntegerField()
    'users_id',#= models.IntegerField()
    'school_sub_class_id',#= models.IntegerField() #
    #district_id= models.IntegerField()
    'school_name',#= models.CharField(max_length=128) #
    'subject_name',#= models.CharField(max_length=64)
    'exams_name',#= models.CharField(max_length=64)#
    'class_levels_name',#= models.CharField(max_length=16)
    'class_name',#= models.CharField(max_length=16) #
    'stream_name',#= models.CharField(max_length=16) #
    'full_name_name',#= models.CharField(max_length=64)#

        )




class StudentSubClassToCopySerializer(serializers.ModelSerializer):
    class Meta:
        model=student_sub_class
        fields=( 
    'id',# = models.BigAutoField(primary_key=True)
    'student',#=models.ForeignKey(student, on_delete=models.CASCADE)
    'school_sub_class',#=models.ForeignKey(school_sub_class, on_delete=models.CASCADE)
    'academic_year',#=models.ForeignKey(academic_year, on_delete=models.CASCADE)
    'status',#=models.CharField(max_length=16)
    

        )

