"""health_clinic_is_01 URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/4.0/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
###SchoolOwnersBySingleOwnerView     OrganizationDirectorsBySingleDirectorView
from django.urls import path
from school.views import (
##c 
# SubClassMergedExamsColumnsView
OrganizationSchoolsFilterWithCategoryAndOrganizationIdView,
LockExamView,
UsersNonParentAnnouncementByCreatorView,
SubClassMergedExamsColumnsView,
SMSToParentsSubClassMergedExamsColumnsView,
SubClassMergedExamsResultsView,
SMSToParentsSubClassMergedExamsResultsView,
OrganizationSchoolsWithCategoryView,
OrganizationSchoolsFilterWithCategoryView,
OrganizationPrimarySchoolsWithCategoryView,
OrganizationSecondarySchoolsWithCategoryView,
AddSchoolPicsAPIViews,
SubClassAttendanceReportView,
SMSToParentsSubClassAttendanceReportView,
SubClassFullAttendanceView,
DeleteAnnoucementView,
UploadPDFView,
UploadPDFEXTView,
PublicAnnouncementsView,
AddOrganizationToOrganizationDirectorView,
AddSchoolToOwnerView,
SchoolOwnersWithoutSchoolsView,
AddSchoolToOrganizationView,
UpdateAnnouncementStatusView,
#UpdateParentAnnouncementStatusView,
UpdateParentsAnnouncementStatusView,
DistrictAVGScorePerSchoolView,
###Organization
OrganizationAVGScorePerSchoolView,

DistrictSingleSubjectAVGResultsView,

OrganizationSingleSubjectAVGResultsView,


CreateOrganizationsView, UpdateOrganizationsView,
CreateSchoolsView, UpdateSchoolsView,
SchoolsView,
SchoolsWithCategoryView,
OrganizationsView,
CitiesView,
DistrictsView,
WardsView,
CreateSchoolAnnouncementView,
CreateSchoolGeneralAnnouncementView,
UserLoginView,

StudentsAttendanceDetailsView,

CreateSchoolAdminView,

CreateSchoolTMTView,

CreateDistrictAdminView,


### CreateOrganizationDirectorsView
CreateOrganizationDirectorsView,

CreateSchoolOwnersView,

DeleteSchoolFromOwnerView,


OnlyExamSubClassView,


SchoolAdminsView,

SchoolTMTView,

DistrictAdminsView,

SchoolOwnersView,

CreateSchoolTeacherView,
SchoolTeachersView,
SingleSchoolTeachersView,
SingleSchoolTeachersAndTMTsView,
OnlySingleSchoolTeachersView,

CreateSchoolStudentView,
CreateSchoolClassView,
DeleteSchoolClassView,

SchoolClassView,
SchoolSubClassView,

SingleSchoolExamsView,

CreateSchoolSubClassView,
DeleteSchoolSubClassView,
GeneralAnnouncementsView,
AcademicYearView,
AllStudentsView,
CreateStudentInAStreamView,
SubjectsView,
CreateExamsView,
ClassLevelsView,
SchoolExamsView,
CreateExamSubjectsView,
ExamSubjectsView,
StudentExamScoreView,
SchoolAdminsView,
UpdateSchoolAdminView,
SchoolStudentsView,
SingleSchoolSubClassView,
SingleSchoolSubClassUsingClassView,

SchoolsSingleView,
SchoolsSingleWithPicsView,
OrganizationDirectorsWithoutOrganizationsView,
#SchoolOwnersWithoutSchoolsView

SchoolOwnersBySingleOwnerView,
OrganizationDirectorsBySingleDirectorView,

AllStudentsWithSubClassesView,
UpdateSchoolStudentView,

SingleTeacherSubjectsView,
CreateSingleTeacherSubjectsView,
DeleteSingleTeacherSubjectsView,
SchoolStudentsExamScoreView,

SchoolStudentsExamScoreViewNew,

SingleTeacherExamSubjectsView,
OnlyExamSubjectsView,
SingleTeacherExamsView,


ExamSubjectsUsingSchoolIdView,
ExamSubjectsUsingSchoolIdAndExamsIdAndSubjectIdView,

DeleteExamSubjectsView,

CopyExamSubjectsToAnotherStreamView,

SingleSchoolClassView,

CreateStreamAttendanceView,
##Details

CreateStudentAttendanceDetailsView,

DeleteExamsView,

SubClassStudentsUsingSubClassAndAcademicYearView,


CopyStudentsToAnotherStreamView,

SingleTeacherExamSubClassView,

SubClassFullExamResultsView,

SMSToParentSubClassFullExamResultsView,

SendExamReportSMSToParentsView,

SendSystemCredentialsToParentsView,

SingleSchoolExamsUsingSchoolIdView,

SingleSchoolExamsUsingSchoolIdViewBySubClass,

SubClassFullExamColumnsView,

SubClassAllExamsColumnsView,

SingleStudentFullExamResultsView,

OnlySingleSchoolParentsView,

DeleteOrganizationFromDirectorView,

SubClassAllExamsResultsView,
SMSToParentSubClassAllExamsResultsView,

ParentReportForSingleStudentFullExamResultsView,
UsersNonParentAnnouncementView,
UsersNonParentAnnouncementWithoutSchoolIdView,
UsersParentAnnouncementByCreatorView,
UsersParentAnnouncementView,
OrganizationSchoolsView,
UpdateSchoolTeacherView,
CreateMarketingBannerView,
MarketingBannersView,
LockedExamsView,
SingleSchoolExamsUnlockedView,
)

###SubClassMergedExamsColumnsView

urlpatterns = [
    
    path('school/SingleSchoolExamsUnlockedViewEXT/<int:schoolId>/<int:academicYearId>/<int:classLevelsId>/<int:subClassId>/',SingleSchoolExamsUnlockedView.as_view()),
    
    path('school/MarketingBannersViewEXT', MarketingBannersView.as_view()),
    
    path('school/CreateMarketingBannerViewEXT', CreateMarketingBannerView.as_view()),
    
    path('school/OrganizationSchoolsViewEXT/<int:organizationId>/',OrganizationSchoolsView.as_view()),
    
    ###LockedExamsView academicYearId, subClassId
    
    path('school/LockedExamsViewEXT/<int:academicYearId>/<int:subClassId>/',LockedExamsView.as_view()),
    
    ###SubClassMergedExamsResultsView
    ###""" """
    ### SubClassMergedExamsColumnsView
    path('school/SubClassMergedExamsResultsViewEXT', SubClassMergedExamsResultsView.as_view()),
    
    ###SMSToParents
    path('school/SMSToParentsSubClassMergedExamsResultsViewEXT', SMSToParentsSubClassMergedExamsResultsView.as_view()),
    
    ###""" """ LockExamView
    path('school/LockExamViewEXT', LockExamView.as_view()),
    
    path('school/SubClassMergedExamsColumnsViewEXT2',SubClassMergedExamsColumnsView.as_view()),
    
    ###SMSToParents
    path('school/SubClassMergedExamsColumnsViewEXT',SubClassMergedExamsColumnsView.as_view()),
    #schoolId, subClassStr, examsStr, academicYearId,
    ### DeleteAnnoucementView
    ###AddSchoolPicsAPIViews
    path('school/AddSchoolPicsAPIViewsEXT', AddSchoolPicsAPIViews.as_view()),
    ###
    path('school/DeleteAnnoucementViewEXT', DeleteAnnoucementView.as_view()),
    
    path('school/UsersNonParentAnnouncementViewEXT/<int:schoolId>/<int:usersId>/', UsersNonParentAnnouncementView.as_view()),
    ###SingleTeacherExamSubClassView
    ##UsersNonParentAnnouncementByCreatorView
    ##UsersNonParentAnnouncementWithoutSchoolIdView
    
    path('school/UsersNonParentAnnouncementWithoutSchoolIdViewEXT/<int:usersId>/', UsersNonParentAnnouncementWithoutSchoolIdView.as_view()),
    
    
    path('school/UsersNonParentAnnouncementByCreatorViewEXT/<int:usersId>/', UsersNonParentAnnouncementByCreatorView.as_view()),
    ###SubClassFullAttendanceView
    path('school/SubClassAttendanceReportViewEXT/<int:schoolId>/<int:subClassId>/<int:academicYearId>/<str:fromDate>/<str:toDate>/', SubClassAttendanceReportView.as_view()),
    ###SubClassAttendanceReportView
    
    path('school/SMSToParentsSubClassAttendanceReportViewEXT/<int:schoolId>/<int:subClassId>/<int:academicYearId>/<str:fromDate>/<str:toDate>/', SMSToParentsSubClassAttendanceReportView.as_view()),
    
    path('school/SubClassFullAttendanceViewEXT/<int:schoolId>/<int:subClassId>/<int:academicYearId>/', SubClassFullAttendanceView.as_view()),
    
    path('school/SingleTeacherExamSubClassViewEXT/<int:schoolId>/<int:usersId>/<int:examsId>/', SingleTeacherExamSubClassView.as_view()),
    
    
    ###GeneralAnnouncementsView
    path('school/GeneralAnnouncementsViewEXT/<str:schoolId>/', GeneralAnnouncementsView.as_view()),
    ###
    path('school/UsersParentAnnouncementViewEXT/<str:phoneNumber>/', UsersParentAnnouncementView.as_view()),
    ###UsersParentAnnouncementByCreatorView
    path('school/UsersParentAnnouncementByCreatorViewEXT/<int:usersId>/', UsersParentAnnouncementByCreatorView.as_view()),
    
    path('school/AddSchoolToOwnerViewEXT', AddSchoolToOwnerView.as_view()),
    
    ###PublicAnnouncementsView
    path('school/PublicAnnouncementsViewEXT', PublicAnnouncementsView.as_view()),
    
    #UploadPDFView
    
    path('school/UploadPDFViewEXT', UploadPDFView.as_view()),
    
    path('school/UploadPDFEXTViewEXT', UploadPDFEXTView.as_view()),
    
    #path('api/home', driverView.as_view()), UsersDetailsView
    #UserLoginView    SchoolAdminsView   CreateSchoolStudentView Teacher
    ### DistrictSingleSubjectAVGResultsView
    ### classLevelsId, academicYearId, subjectId
    ### DistrictAVGScorePerSchoolView
    
    path('school/AddSchoolToOrganizationViewEXT', AddSchoolToOrganizationView.as_view()),
    
    ###CreateSchoolAnnouncementView AddSchoolToOrganizationView
    
    path('school/CreateSchoolAnnouncementViewEXT', CreateSchoolAnnouncementView.as_view()),
    
    path('school/CreateSchoolGeneralAnnouncementViewEXT', CreateSchoolGeneralAnnouncementView.as_view()),
    
    path('school/OrganizationAVGScorePerSchoolViewEXT/<int:classLevelsId>/<int:academicYearId>/<int:organizationId>/', OrganizationAVGScorePerSchoolView.as_view()),
    ###Organization
    
    path('school/DistrictAVGScorePerSchoolViewEXT/<int:classLevelsId>/<int:academicYearId>/', DistrictAVGScorePerSchoolView.as_view()),
    
    
    path('school/OrganizationSingleSubjectAVGResultsViewEXT/<int:classLevelsId>/<int:academicYearId>/<int:subjectId>/<int:organizationId>/', OrganizationSingleSubjectAVGResultsView.as_view()),
    ### Organization
    
    
    path('school/DistrictSingleSubjectAVGResultsViewEXT/<int:classLevelsId>/<int:academicYearId>/<int:subjectId>/', DistrictSingleSubjectAVGResultsView.as_view()),
    
    path('school/ParentReportForSingleStudentFullExamResultsViewEXT/<str:linkStr>/', ParentReportForSingleStudentFullExamResultsView.as_view()),
    
    path('school/SchoolTeachersViewEXT', SchoolTeachersView.as_view()),
    
    path('school/UpdateAnnouncementStatusViewEXT', UpdateAnnouncementStatusView.as_view()),
    
    #            UpdateParentsAnnouncementStatusView
    path('school/UpdateParentsAnnouncementStatusViewEXT', UpdateParentsAnnouncementStatusView.as_view()),

    path('school/SingleSchoolTeachersViewEXT/<int:schoolId>/', SingleSchoolTeachersView.as_view()),
    
    ### SingleSchoolTeachersAndTMTsView
    
    path('school/SingleSchoolTeachersAndTMTsViewEXT/<int:schoolId>/', SingleSchoolTeachersAndTMTsView.as_view()),
    
    path('school/OnlySingleSchoolTeachersViewEXT/<int:schoolId>/', OnlySingleSchoolTeachersView.as_view()),
    
    path('school/OnlySingleSchoolParentsViewEXT/<int:schoolId>/<int:academicYearId>/', OnlySingleSchoolParentsView.as_view()),

    path('school/SchoolAdminsViewEXT', SchoolAdminsView.as_view()),
    
    path('school/DistrictAdminsViewEXT', DistrictAdminsView.as_view()),
    # SchoolOwner
    path('school/DeleteOrganizationFromDirectorViewEXT', DeleteOrganizationFromDirectorView.as_view()),
    #DeleteOrganizationFromDirectorView
    
    path('school/DeleteSchoolFromOwnerViewEXT', DeleteSchoolFromOwnerView.as_view()),
    
    path('school/OrganizationDirectorsBySingleDirectorViewEXT/<int:usersId>/', OrganizationDirectorsBySingleDirectorView.as_view()),
    
    #DeleteSchoolFromOwnerView OrganizationDirectorsBySingleDirectorView
    path('school/StudentsAttendanceDetailsViewEXT/<int:schoolId>/<int:subClassId>/<int:academicYearId>/<str:attendanceDate>/', StudentsAttendanceDetailsView.as_view()),
    # StudentsAttendanceDetailsView
    
    path('school/SchoolOwnersBySingleOwnerViewEXT/<int:usersId>/', SchoolOwnersBySingleOwnerView.as_view()),
    
    ###CreateStudentAttendanceView Details
    
    path('school/CreateStreamAttendanceViewEXT', CreateStreamAttendanceView.as_view()),
    
    path('school/CreateStudentAttendanceDetailsViewEXT', CreateStudentAttendanceDetailsView.as_view()),
    
    ###AddOrganizationToOrganizationDirectorView
    path('school/AddOrganizationToOrganizationDirectorViewEXT', AddOrganizationToOrganizationDirectorView.as_view()),
    ###SchoolOwnersWithoutSchoolsView
    
    path('school/OrganizationDirectorsWithoutOrganizationsViewEXT', OrganizationDirectorsWithoutOrganizationsView.as_view()),
    ###OrganizationDirectorsWithoutOrganizationsView,
    
    path('school/SchoolOwnersWithoutSchoolsViewEXT', SchoolOwnersWithoutSchoolsView.as_view()),
    
    path('school/SchoolOwnersViewEXT', SchoolOwnersView.as_view()),
    
    path('school/UserLoginViewEXT', UserLoginView.as_view()),
    path('school/WardsViewEXT', WardsView.as_view()),
    
    path('school/DistrictsViewEXT', DistrictsView.as_view()),

    path('school/CitiesViewEXT', CitiesView.as_view()),

    path('school/SchoolsViewEXT', SchoolsView.as_view()),
    
    path('school/OrganizationSchoolsWithCategoryViewEXT', OrganizationSchoolsWithCategoryView.as_view()),
    
    path('school/OrganizationSchoolsFilterWithCategoryViewEXT/<int:organizationId>/', OrganizationSchoolsFilterWithCategoryView.as_view()),
    
    ### OrganizationSchoolsFilterWithCategoryAndOrganizationIdView
    path('school/OrganizationSchoolsFilterWithCategoryAndOrganizationIdViewEXT/<int:organizationId>/<str:category>/', OrganizationSchoolsFilterWithCategoryAndOrganizationIdView.as_view()),
    
    path('school/OrganizationPrimarySchoolsWithCategoryViewEXT', OrganizationPrimarySchoolsWithCategoryView.as_view()),
    
    path('school/OrganizationSecondarySchoolsWithCategoryViewEXT', OrganizationSecondarySchoolsWithCategoryView.as_view()),
    
    ### OrganizationSchoolsWithCategoryView
    
    path('school/SchoolsWithCategoryViewEXT/<str:category>/', SchoolsWithCategoryView.as_view()),
    
    ###SchoolsSingleView
    
    path('school/SchoolsSingleViewEXT/<int:schoolId>/', SchoolsSingleView.as_view()),
    
    path('school/SchoolsSingleWithPicsViewEXT/<int:schoolId>/', SchoolsSingleWithPicsView.as_view()),
    
    path('school/CreateSchoolsViewEXT', CreateSchoolsView.as_view()),
    path('school/UpdateSchoolsViewEXT', UpdateSchoolsView.as_view()),
    
    #Organization
    path('school/OrganizationsViewEXT', OrganizationsView.as_view()),
    
    path('school/CreateOrganizationsViewEXT', CreateOrganizationsView.as_view()),
    path('school/UpdateOrganizationsViewEXT', UpdateOrganizationsView.as_view()),
    
    path('school/CreateSchoolAdminViewEXT', CreateSchoolAdminView.as_view()),
    
    path('school/CreateOrganizationDirectorsViewEXT', CreateOrganizationDirectorsView.as_view()),
    
    # CreateSchoolOwnersView CreateOrganizationDirectorsView
    
    path('school/CreateSchoolTMTViewEXT', CreateSchoolTMTView.as_view()),
    
    path('school/CreateSchoolOwnersViewEXT', CreateSchoolOwnersView.as_view()),
    
    path('school/CreateDistrictAdminViewEXT', CreateDistrictAdminView.as_view()),
    
    path('school/UpdateSchoolAdminViewEXT', UpdateSchoolAdminView.as_view()),
    
    path('school/UpdateSchoolTeacherViewEXT', UpdateSchoolTeacherView.as_view()),

    path('school/CreateSchoolTeacherViewEXT', CreateSchoolTeacherView.as_view()),
    #path('school/UpdateSchoolAdminViewEXT', UpdateSchoolAdminView.as_view()),

    path('school/CreateSchoolStudentViewEXT', CreateSchoolStudentView.as_view()),
    path('school/UpdateSchoolStudentViewEXT', UpdateSchoolStudentView.as_view()),

    path('school/CreateSchoolClassViewEXT', CreateSchoolClassView.as_view()),

    path('school/DeleteSchoolClassViewEXT', DeleteSchoolClassView.as_view()),
    
    ###SchoolClassView   CreateSchoolSubClassView   AllStudentsView
    ### SchoolAdminsView
    ### /<str:serviceCategory>/ AllStudentsWithSubClassesView SingleTeacherSubjectsView,
    ###CreateSingleTeacherSubjectsView
    ###SchoolStudentsExamScoreView
    ###schoolId, subClassId, examsId, subjectId, academicYearId,
    ####SingleTeacherExamSubjectsView
    ###SingleSchoolExamsView
    ###SubClassStudentsUsingSubClassAndAcademicYearView academicYearId
    ###SingleSchoolExamsView
    ### SubClassFullExamColumnsView

    path('school/SubClassAllExamsColumnsViewEXT/<int:academicYearId>/<int:subClassId>/', SubClassAllExamsColumnsView.as_view()),
    

    path('school/SubClassFullExamColumnsViewEXT/<int:examsId>/<int:subClassId>/', SubClassFullExamColumnsView.as_view()),
    
    
    path('school/SingleSchoolExamsUsingSchoolIdViewEXT/<int:schoolId>/<int:academicYearId>/<int:classLevelsId>/', SingleSchoolExamsUsingSchoolIdView.as_view()),
    
    path('school/SingleSchoolExamsUsingSchoolIdViewBySubClassEXT/<int:schoolId>/<int:academicYearId>/<int:subClassId>/', SingleSchoolExamsUsingSchoolIdViewBySubClass.as_view()),
    
    path('school/SingleSchoolExamsUsingSchoolIdViewEXTold/<int:schoolId>/', SingleSchoolExamsUsingSchoolIdView.as_view()),
    
    
    path('school/SingleStudentFullExamResultsViewEXT/<int:schoolId>/<int:examsId>/<int:subClassId>/<int:academicYearId>/<int:studentId>/', SingleStudentFullExamResultsView.as_view()),
    

    path('school/SubClassFullExamResultsViewEXT/<int:schoolId>/<int:examsId>/<int:subClassId>/<int:academicYearId>/', SubClassFullExamResultsView.as_view()),
    
    path('school/SMSToParentSubClassFullExamResultsViewEXT/<int:schoolId>/<int:examsId>/<int:subClassId>/<int:academicYearId>/', SMSToParentSubClassFullExamResultsView.as_view()),
    
    ###SendExamReportSMSToParentsView
    path('school/SendExamReportSMSToParentsViewEXT', SendExamReportSMSToParentsView.as_view()),
    
    path('school/SendSystemCredentialsToParentsViewEXT', SendSystemCredentialsToParentsView.as_view()),
    
    ### SMSToParentSubClassAllExamsResultsView
    
    path('school/SubClassAllExamsResultsViewEXT/<int:schoolId>/<int:subClassId>/<int:academicYearId>/', SubClassAllExamsResultsView.as_view()),
    
    path('school/SMSToParentSubClassAllExamsResultsViewEXT/<int:schoolId>/<int:subClassId>/<int:academicYearId>/', SMSToParentSubClassAllExamsResultsView.as_view()),
    
    #path('school/SubClassAllExamsResultsViewEXT/<int:schoolId>/<int:subClassId>/<int:academicYearId>/', SubClassAllExamsResultsView.as_view()),
    
    
    path('school/SubClassStudentsUsingSubClassAndAcademicYearViewEXT/<int:schoolId>/<int:subClassId>/<int:academicYearId>/', SubClassStudentsUsingSubClassAndAcademicYearView.as_view()),
    
    
    path('school/SingleSchoolExamsViewEXT/<int:schoolId>/<int:academicYearId>/<int:classLevelsId>/', SingleSchoolExamsView.as_view()),
    

    path('school/SingleTeacherExamsViewEXT/<int:schoolId>/<int:usersId>/', SingleTeacherExamsView.as_view()),
    
    path('school/SingleTeacherExamSubjectsViewEXT/<int:schoolId>/<int:usersId>/<int:examsId>/', SingleTeacherExamSubjectsView.as_view()),
    
    
    path('school/OnlyExamSubjectsViewEXT/<int:schoolId>/<int:examsId>/', OnlyExamSubjectsView.as_view()),
    
    path('school/OnlyExamSubClassViewEXT/<int:schoolId>/<int:examsId>/', OnlyExamSubClassView.as_view()),
    

    path('school/SchoolStudentsExamScoreViewEXT/<int:schoolId>/<int:subClassId>/<int:examsId>/<int:subjectId>/<int:academicYearId>/', SchoolStudentsExamScoreView.as_view()),
    
    path('school/SchoolStudentsExamScoreViewNewEXT/<int:schoolId>/<int:subClassId>/<int:examsId>/<int:examSubjectId>/<int:academicYearId>/', SchoolStudentsExamScoreViewNew.as_view()),
    
    path('school/CreateSingleTeacherSubjectsViewEXT', CreateSingleTeacherSubjectsView.as_view()),

    path('school/DeleteSingleTeacherSubjectsViewEXT', DeleteSingleTeacherSubjectsView.as_view()),
    
    path('school/SingleTeacherSubjectsViewEXT/<int:schoolId>/<int:usersId>/', SingleTeacherSubjectsView.as_view()),
    
    
    path('school/AllStudentsWithSubClassesViewEXT/<int:schoolId>/', AllStudentsWithSubClassesView.as_view()),
   
    path('school/SchoolStudentsViewEXT/<int:schoolId>/', SchoolStudentsView.as_view()),

    path('school/SchoolAdminsViewEXT', SchoolAdminsView.as_view()),
    
    path('school/SchoolTMTViewEXT/<str:userCategory>/<int:organizationId>/', SchoolTMTView.as_view()),

    path('school/AllStudentsViewEXT', AllStudentsView.as_view()),

    path('school/SchoolClassViewEXT', SchoolClassView.as_view()),

    path('school/SingleSchoolClassViewEXT/<int:schoolId>/', SingleSchoolClassView.as_view()),

    path('school/SchoolSubClassViewEXT', SchoolSubClassView.as_view()),

    path('school/SingleSchoolSubClassViewEXT/<int:schoolId>/', SingleSchoolSubClassView.as_view()),

    path('school/SingleSchoolSubClassUsingClassViewEXT/<int:schoolId>/<int:classId>/', SingleSchoolSubClassUsingClassView.as_view()),

    path('school/AcademicYearViewEXT', AcademicYearView.as_view()),

    path('school/SubjectsViewEXT', SubjectsView.as_view()),

    path('school/ClassLevelsViewEXT', ClassLevelsView.as_view()),

    path('school/SchoolExamsViewEXT', SchoolExamsView.as_view()),

    path('school/DeleteExamsViewEXT', DeleteExamsView.as_view()),
    
    path('school/ExamSubjectsViewEXT', ExamSubjectsView.as_view()),
    
    ### ExamSubjectsUsingSchoolIdView

    path('school/ExamSubjectsUsingSchoolIdViewEXT/<int:schoolId>/', ExamSubjectsUsingSchoolIdView.as_view()),
    
    path('school/ExamSubjectsUsingSchoolIdAndExamsIdAndSubjectIdViewEXT/<int:schoolId>/<int:examsId>/<int:subClassId>/', ExamSubjectsUsingSchoolIdAndExamsIdAndSubjectIdView.as_view()),
    
    
    path('school/CopyExamSubjectsToAnotherStreamViewEXT', CopyExamSubjectsToAnotherStreamView.as_view()),
    ### CopyExamSubjectsToAnotherStreamView
    
    path('school/CopyStudentsToAnotherStreamViewEXT', CopyStudentsToAnotherStreamView.as_view()),
    
    path('school/CreateSchoolSubClassViewEXT', CreateSchoolSubClassView.as_view()),

    path('school/DeleteSchoolSubClassViewEXT', DeleteSchoolSubClassView.as_view()),

    #CreateStudentInAStreamView    SubjectsView CreateExamsView   ClassLevelsView
    path('school/CreateStudentInAStreamViewEXT', CreateStudentInAStreamView.as_view()),
    ### SchoolExamsView   ExamSubjectsView   StudentExamScoreView
    path('school/CreateExamsViewEXT', CreateExamsView.as_view()),

    path('school/CreateExamSubjectsViewEXT', CreateExamSubjectsView.as_view()),
    path('school/DeleteExamSubjectsViewEXT', DeleteExamSubjectsView.as_view()),


    path('school/CreateStudentExamScoreViewEXT', StudentExamScoreView.as_view()),
    
    
]
