from django.db.models import Q
from datetime import date
from datetime import timedelta
import datetime


#from PIL import Image
from django.http import FileResponse
import os


from school.models import(
    users, user_login_category, login_category,
    school_user,
    school,
    student,
    school_student,
    )
class usersC:
    
    def getDateAfterDays(self, numberDays):
        new_date=''
        try:

            current_date = date.today()
            old_date = current_date #+ timedelta(days=-7)
            new_date = current_date + timedelta(days=180)
        except Exception as e:
            print("try catch error A0103: " + str(e))
        return new_date
    
    def convertDateToYMD(self, dateArg):
        dateYMD=''
        try:
            dateYMD=''
            #dDate=datetime.date.today()
            yYear=str(dateArg.year)
            mMonth=str(dateArg.month)
            dDay=str(dateArg.day)
            dateYMD=yYear + '-' + mMonth + '-' + dDay
        except Exception as e:
            print("try catch error A0107: " + str(e))
        
        return dateYMD
    
    def getTodayDate(self):
        todayDateStr=''
        try:
            todayDate=datetime.date.today()
            todayYear=str(datetime.date.today().year)
            todayMonth=str(datetime.date.today().month)
            todayDay=str(datetime.date.today().day)
            if len(todayMonth)==1:
                todayMonth='0' + todayMonth
            if len(todayDay)==1:
                todayDay='0' + todayDay

            todayDateStr= todayYear + '-' + todayMonth + '-' + todayDay
        except Exception as e:
            print("try catch error A0109: " + str(e))
        
        return todayDateStr

    def getTodayTime(self):
        todayTimeStr=''
        try:
            todayTime=datetime.datetime.now()
            todayHour=str(datetime.datetime.now().hour)
            todayMinute=str(datetime.datetime.now().minute)
            todaySecond=str(datetime.datetime.now().second)

            todayTimeStr= todayHour + ':' + todayMinute + ':' + todaySecond + '.000000'
        except Exception as e:
            print("try catch error A0121: " + str(e))
        
        return todayTimeStr
    
    
    
   
    def lookIfMobileNoExists(self, mobileNumber):
        x=0
        msg=""
        try:
            x=x
            ixc=users.objects.values().filter(mobile_number=mobileNumber, status='Active')
            x=len(list(ixc))
            msg="success"
        except Exception as e:
            msg="error failed : " + str(e)
        return [x, msg]
    

    def getUserIdUsingMobileNo(self, mobileNumber):
        x=0
        msg=""
        id=0
        try:
            x=x
            ixc=users.objects.values().filter(mobile_number=mobileNumber, status='Active')
            for a in ixc:
                id=a['id']
            if id>0:
                msg="success"

            
        except Exception as e:
            msg="error failed : " + str(e)
        return [id, msg]
    
    def getStudentIdUsingStudentDetails(self, firstName, middleName, lastName, firstMobileNumber, secondMobileNumber):
        x=0
        msg=""
        id=0
        try:
            x=x
            ixc=student.objects.values().filter(
                    first_name=firstName,
                    middle_name=middleName,
                    last_name=lastName,
                    first_mobile_number=firstMobileNumber,
                    second_mobile_number=secondMobileNumber,
                    status= 'Active',
                )
            for a in ixc:
                id=a['id']
            if id>0:
                msg="success"

            
        except Exception as e:
            msg="error failed : " + str(e)
        return [id, msg]
    

    
    def getUserLoginCategoryIdUsingCategoryName(self, categoryName):
        x=0
        msg=""
        id=0
        try:
            x=x
            ixc=login_category.objects.values().filter(name=categoryName, status='Active')
            for a in ixc:
                id=a['id']
            if id>0:
                msg="success"

            
        except Exception as e:
            msg="error failed : " + str(e)
        return [id, msg] 
    


    
    def getUserSchoolNameUsingUserId(self, userId):
        x=0
        msg="not success"
        id=0
        schoolId=0
        schoolName=""
        try:
            x=x
            ixc=school_user.objects.values().filter(users_id=userId, status='Active')
            
            for a in ixc:
                schoolId=a['school_id']
                id=1
            
            if id>0:
                msg="success"

            icx=school.objects.values().filter(id=schoolId, status='Active')
            
            for a in icx:
                schoolName=a['name']
                id=1

            
        except Exception as e:
            msg="error failed : " + str(e)
        return [schoolId, schoolName, msg]
       
    
    
   
    def getStudentNameUsingStudentId(self, studentId):
        x=0
        msg="not success"
        id=0
        #studentId=0
        studentName=""
        try:
            x=x
            ixc=student.objects.values().filter(id=studentId)
            print("len=" + str(len(list(ixc))))
            for a in ixc:
                studentName=a['first_name'] + " " +  a['middle_name'] + " " + a['last_name']
                id=1
            
            
        except Exception as e:
            msg="error failed : " + str(e)
            print(msg)
        return studentName
       
    